unit generic;

interface

uses ComObj,activex,ShellApi, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Inifiles, Dialogs, StdCtrls,utils, ExtCtrls, ComCtrls;


type
   relType = shortint;
   T2DRelTypeArray = array of array of relType;

   {this class allows drag & drop from external applications}
   TDropTarget = class(TComponent, IDropTarget)
   private
   protected
    function DragEnter(const DataObj: IDataObject; grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HRESULT; stdcall;
    function DragOver(grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HRESULT; stdcall;
    function DragLeave: HRESULT; stdcall;
    function Drop(const dataObj: IDataObject; grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HRESULT; stdcall;
   public
   end;

   // represents a news item found on a feed
   TItem = Record
      uniqueId : string;
      title: string;
      description: string;
      link: string;
      imageUrl: string;
      imageNumber: integer;
      imageDownloadAttempts: integer;
      imageHeight, imageWidth: integer;
      header: string;
      relevanceRatingFromHistory: integer;
      relevanceRatingFromUser: integer;
      previousRelevanceRatingFromUser : integer;
      reapplyRelevance: boolean;
      timestamp: TDateTime;
      read: boolean;
      keep: boolean;
      savedToDisk: boolean;
   end;
   PItem = ^TItem;

   // represents the details of a particular feed
   TFeed = Record
      url: string;
      active: boolean;
      showAllArticles: boolean;
      keywordSets : TStringList;
      refreshInterval: integer;
      lastRefresh: COMP;
   end;

   Items = array of TItem;
   PItems = array of PItem;

   // a link between two words
   TWordLink = Record
      word1: integer;
      word2: integer;
      strength: relType;
   end;

   TWordLinks = array of TWordLink;

   TKeywordSet = Record
      name: string;
      keywords : TStringList;
   end;


implementation


uses feeds;





function TDropTarget.DragEnter(const dataObj: IDataObject; grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HRESULT;
begin
  Result := S_OK;
end;


function TDropTarget.DragOver(grfKeyState: Longint; pt: TPoint;
  var dwEffect: Longint): HResult;
begin
	Result := S_OK;
end;


function TDropTarget.DragLeave: HResult;
begin
    Result := S_OK;
end;


function TDropTarget.Drop(const dataObj: IDataObject; grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HResult;
var
  FmtEtc: TFormatEtc;
  Medium: TStgMedium;
  PText: PChar;
begin
  FmtEtc.cfFormat := CF_TEXT;
  FmtEtc.ptd := nil;
  FmtEtc.dwAspect := DVASPECT_CONTENT;
  FmtEtc.lindex := -1;
  OleCheck(DataObj.GetData(FmtEtc, Medium));

    try
      PText := GlobalLock(Medium.hGlobal);
      try
        frmFeeds.txtAddFeedURL.Text := strpas(PText);
        frmFeeds.btnAddFeedClick(nil);
      finally
        GlobalUnlock(Medium.hGlobal);
      end;
    finally
      ReleaseStgMedium(Medium);
    end;

       Result := S_OK;

end;





end.
