unit keywordsets;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, generic,utils;

type
  TfrmKeywordSets = class(TForm)
    pnlButtons: TPanel;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Splitter2: TSplitter;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    txtKeywords: TMemo;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lbKeywordSets: TListBox;
    Label8: TLabel;
    Label9: TLabel;
    pnlKeywordSetsButtons: TPanel;
    Label7: TLabel;
    btnDelete: TButton;
    btnAdd: TButton;
    txtNewKeywordSet: TEdit;
    procedure btnAddClick(Sender: TObject);
    procedure lbKeywordSetsClick(Sender: TObject);
    procedure txtKeywordsExit(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    closeOk: boolean;
  public
    { Public declarations }
    keywordSetList: array of TKeywordSet;

  end;

var
  frmKeywordSets: TfrmKeywordSets;

implementation

{$R *.dfm}


procedure TfrmKeywordSets.btnAddClick(Sender: TObject);
var
   i: integer;
begin
   if (txtNewKeywordSet.text = '') or (txtNewKeywordSet.text = '[new keyword set]') then
   begin
      ShowMessage('Please enter the name of the new keyword set');
      txtNewKeywordSet.SetFocus;
      exit;
   end;

   for i := 0 to length(keywordSetList)-1 do
   begin
      if keywordSetList[i].name = txtNewKeywordSet.text then
      begin
         ShowMessage('Keyword set with this name already exists');
         exit;
      end;
   end;

   lbKeywordSets.items.add(txtNewKeywordSet.text);
   setLength(keywordSetList, length(keywordSetList)+1);
   with keywordSetList[length(keywordSetList)-1] do
   begin
      name := txtNewKeywordSet.text;
      keywords := TStringList.create;
   end;

   lbKeywordSets.ItemIndex := lbKeywordSets.Items.Count-1;
   lbKeywordSets.OnClick(nil);
end;

procedure TfrmKeywordSets.btnDeleteClick(Sender: TObject);
var
   i: integer;
begin
   if lbKeywordSets.ItemIndex > -1 then
   begin
      if MessageDlg('Delete keyword set?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
         for i := lbKeywordSets.ItemIndex to lbKeywordSets.Count-2 do
            keywordSetList[i] := keywordSetList[i+1];
         setLength(keywordSetList, length(keywordSetList)-1);
         lbKeywordSets.Items.Delete(lbKeywordSets.ItemIndex);

         // if any remaining keyword sets, select the last one
         if lbKeywordSets.Items.Count > 0 then
         begin
            lbKeywordSets.ItemIndex := lbKeywordSets.Items.Count-1;
            lbKeywordSets.OnClick(nil);
         end
         else
         begin
            txtKeywords.Clear;
            txtKeywords.Enabled := false;
         end;

      end;
   end
   else
      ShowMessage('Please select a keyword set to delete');
end;

procedure TfrmKeywordSets.Button1Click(Sender: TObject);
begin
   if MessageDlg('Save changes?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      closeOk := true;
      ModalResult := mrOk;
   end;
end;

procedure TfrmKeywordSets.Button2Click(Sender: TObject);
begin
   if MessageDlg('Abandon changes?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      closeOk := true;
      ModalResult := mrCancel;
   end;
end;


procedure TfrmKeywordSets.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   CanClose := closeOk;
end;

procedure TfrmKeywordSets.FormCreate(Sender: TObject);
begin
   closeOk := false;
end;

procedure TfrmKeywordSets.lbKeywordSetsClick(Sender: TObject);
var
   keywordSet: TKeywordSet;
begin
   keywordSet := keywordSetList[lbKeywordSets.itemIndex];
   txtKeywords.Text := unparseString(keywordSet.keywords, chr(13)+chr(10));
   txtKeywords.Enabled := true;
end;

procedure TfrmKeywordSets.txtKeywordsExit(Sender: TObject);
begin
   with keywordSetList[lbKeywordSets.itemIndex] do
   begin
      keywords.free; // free previous list
      keywords.sorted := true;
      keywords := parseString(txtKeywords.Text,chr(13)+chr(10));
      removeDuplicates(keywords);
   end;
end;

end.
