unit main;

interface

uses
  ComObj,activex,ShellApi, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Grids, StdCtrls, IniFiles, ComCtrls,IdHTTP,IdHTTPHeaderInfo,IdSSLOpenSSL,
  LibXmlParser,jpeg,syncobjs,math,feeds,linklabel,generic,utils,shortintmap,compmap,
  Menus,pngimage,axctrls,about,newsticker;

const
   WM_NOTIFYICON  = WM_USER+333;
   
   CR = '{CR}';
   LF = '{LF}';


type

   keywordScanResult = record
     matchingKeywords: string;
     matchCount: integer;
   end;


  TMainThread = class(TThread)
  private
   isRunning: boolean;
   frmOwner: TForm;
   private
     procedure downloadOutstandingImages;
     function downloadFile(url: string; downloadFileName: string; checkLastModified: boolean; lastRefresh: COMP): string;
     procedure sortFeedsByLastRefreshTime;
     procedure searchAll;
     // function feedsDownloadedToday: integer;
     procedure scanFeed(var feed: TFeed; var listToAddTo:Items);
     procedure doScan(var feed: TFeed; var item:TItem; var itemList: Items);
     function scanKeywords(var feed: TFeed; textToSearch: string): keywordScanResult;
     procedure handleFoundItems(var matchingItems: Items);
     procedure updateUserRatings;
     procedure log(line: string; isVerbose: boolean);
     procedure saveArticlesToKeep;
  protected
    procedure Execute; override;
  public
    constructor create(_frmOwner: TForm);
    destructor Destroy; override;
    function isThreadRunning: boolean;
    procedure cleanItem(var item: TItem);
    function checkRelevance(theText: string): integer;
    function checkSimpleRelevance(var words: TStringList): integer;
    function checkRelevanceInRelTable(var words: TStringList): integer;
    function getCleanWordList(theText: string): TStringList;
    function findLinkIndex(index1, index2: integer): integer;
    function findKeywordSetByName(name: string): TKeywordSet;
    procedure updateRelevance(relevance: integer; theText: string);
    procedure updateRelTable(var words: TStringList; relevance: integer);
    function isSupportedImage(filename: string): boolean;
  end;

  TfrmMain = class(TForm)
    pnlLeft: TPanel;
    sgArticles: TStringGrid;
    Splitter1: TSplitter;
    pnlRight: TPanel;
    txtContents: TMemo;
    pnlHyperlink: TPanel;
    Splitter2: TSplitter;
    pnlTopHeader: TPanel;
    lblHeading: TLabel;
    pnlBottomRight: TPanel;
    pnlFeedback: TPanel;
    pnlUserRating: TPanel;
    lblIrrelevant: TLabel;
    lblRateHeading: TLabel;
    lblTotallyRelevant: TLabel;
    gbRelevance: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    Label5: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    RadioButton21: TRadioButton;
    btnShowRelevance: TButton;
    pnlGridButtons: TPanel;
    pnlArticleGridButtons: TPanel;
    pnlArticlesGridButtonsFixed: TPanel;
    btnFirst: TButton;
    btnPrevious: TButton;
    btnNext: TButton;
    btnLast: TButton;
    txtResults: TMemo;
    txtSearch: TEdit;
    btnSearch: TButton;
    Image1: TImage;
    cbShowReadUnread: TComboBox;
    cbShowNewOld: TComboBox;
    cbRatedUnrated: TComboBox;
    cbShowKeptUnkept: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Actions1: TMenuItem;
    Exit1: TMenuItem;
    Markallread1: TMenuItem;
    Markallunread1: TMenuItem;
    Keepall1: TMenuItem;
    Unkeepall1: TMenuItem;
    Config1: TMenuItem;
    Reset1: TMenuItem;
    Resetfeedlastscantimes1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Visitwebpage1: TMenuItem;
    Newsticker1: TMenuItem;
    cbKeepThisArticle: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure sgArticlesSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure RadioButton1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnShowRelevanceClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnFirstClick(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnLastClick(Sender: TObject);
    procedure sgArticlesDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure btnSearchClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure cbKeepThisArticleClick(Sender: TObject);
    procedure cbShowReadUnreadChange(Sender: TObject);
    procedure cbShowKeptUnkeptChange(Sender: TObject);
    procedure cbShowNewOldChange(Sender: TObject);
    procedure cbRatedUnratedChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Markallread1Click(Sender: TObject);
    procedure Markallunread1Click(Sender: TObject);
    procedure Keepall1Click(Sender: TObject);
    procedure Unkeepall1Click(Sender: TObject);
    procedure Config1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Resetfeedlastscantimes1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Visitwebpage1Click(Sender: TObject);
    procedure Newsticker1Click(Sender: TObject);
  private
    { Private declarations }
    dropTarget: TDropTarget;
    uniqueSeq: integer;
    shownHelp: boolean;
    TrayIcon: TNotifyIconData;
    HMainIcon: HICON;
    cellChanging: boolean;
    procedure testProxy;
    procedure displayingSomeArticles(showingSome: boolean);
    procedure keepAllSelected(keep: boolean);
    procedure markAllSelectedRead(read: boolean);
    procedure showImage(imageFileName: string; width: integer; height: integer);
    procedure showArticle(index: integer);
    function findArticleByUniqueId(id: string): integer;
    function getRelevance: integer;
    procedure setRelevance(relevance: integer);
    procedure loadWordWeightingsTable(filename: string);
    function loadOldRelTable(filename: string): boolean;
    procedure loadKeptArticles;
    procedure sortItemList(var itemsToSort: Items);
    function findArticleInMainList(var item: TItem): integer;
    procedure loadLinksTable;
    procedure saveLinksTable;
    // procedure Save2DShortArray(const A: T2DRelTypeArray; filename: string);
    procedure Load2DShortArray(var A: T2DRelTypeArray; filename: string);
    //function getRelevantWordCount: integer;
    procedure log(line: string; isVerbose: boolean);
    procedure bringApplicationToFront(forceToForeground: boolean);
    procedure displayAlertIcon;
    function getUniqueId: string;
    procedure subscribeToFeed(args: string);
    procedure WMCopyData(var Msg : TWMCopyData); message WM_COPYDATA;
  public
    { Public declarations }
    continuousScan, showImages, resetUnreadArticlesOnExit: boolean;
    logEntry: string;
    procedure setLinkPanelHeight;
    procedure initialise;
    procedure loadConfig(confFile: TIniFile);
    procedure saveUpdatedConfig;
    procedure saveAllConfig;
    procedure saveData;
    procedure addItems(var newItems: Items);
    procedure sortItems;
    procedure displayItems;
    procedure cleanData;
    procedure logFromOtherThread;
    procedure updateTrayIconText(newText: string);
    procedure ClickTrayIcon(var msg: TMessage); message WM_NOTIFYICON;
    procedure MinimizeClick(Sender:TObject);
    function itemInList(var item:TItem; var itemList: Items): boolean;
    function urlShownRecently(url: string): boolean;
    procedure dumpLinkTable;
    procedure alertUser;
    procedure freeNewsTicker;
    function getOldArticleCutoffTime: TDateTime;
  end;



const
   COLUMN_TITLE = 0;
   COLUMN_REASON = 1;
   COLUMN_USER_RATING = 2;
   COLUMN_READ = 3;
   COLUMN_TIMESTAMP = 4;
   tempFile = 'temp.xml';
   iniPrefix = 'rss';
   sep = '---***---';
   shownUrlsFile = 'shownfeedurls.dat';
   wordWeightingsFile = 'wordweightings.dat';
   oldRelTableFile = 'reltable.dat';
   linksTableFile = 'wordlinks.dat';
   NOT_DOWNLOADING = 'NOT DOWNLOADING';
   confFileName = 'pheedstorm.conf';
   appVersion = '2.10';
   MINUTE = 60000;
   SOCKET_TIMEOUT = 60000;
   mainIcon = 'MAINICON';
   alertIcon = 'ARTICLESFOUNDICON';
   ALERT_CHANGEICON = 0;
   ALERT_FLASHTASKBAR = 1;
   ALERT_FORCETOFOREGROUND = 2;


var
  frmMain: TfrmMain;
  mainThread: TMainThread;
  proxyDetails: TIdProxyConnectionInfo;
  speakTitles, speakArticles: boolean;
  linkLabel: TLinkLabel;
  wordLinks: TWordLinks;
  commonWords: TStringList;
  relevantWords: TShortIntMap;
  relevantWordsChanged: boolean;
  urlsShownRecently: TCompMap;
  urlsShownRecentlyChanged: boolean;
  initialised, shownWelcome, firstTime, feedsFormShowing: boolean;
  runAfterIdleFor: integer;
  verboseOutput,backupDataFiles: boolean;
  appStartTime, lastSavedData, saveDataInterval, lastUserInteraction: COMP;
  minWordLength,maxWordLength,maxWordWeight,maxDownloadsPerDay: integer;
  repeatInterval,alertMechanism: cardinal;
  downloadDir,dataDir, articlesDir: string;
  feedsList: array of TFeed;
  keywordSetList: array of TKeywordSet;
  articles: Items;
  articlesDisplayed: PItems;
  savingFromThread, updatingGUI, updatingGrid: boolean;
  imageSeq: integer;
  downloadFeeds, downloadImages, saveXml: boolean;
  interrupted: boolean;
  saveLock,articleLock : TCriticalSection;
  frmNewsTicker: TfrmNewsTicker;
  fontSize: integer;


implementation

uses splashscreen;

{$R *.dfm}
{$R pheedstormext.res}


procedure TfrmMain.updateTrayIconText(newText: string);
begin
   StrPLCopy(trayIcon.szTip, newText, SizeOf(trayIcon.szTip) - 1);
   application.processmessages;
end;



procedure TfrmMain.initialise;
var
   confFile: TIniFile;
   cmdLineArgs: string;
begin
   // don't do this now otherwise a second instance cannot find this one
   // as it looks this up by window title
   // self.caption := self.caption + ' ' + appVersion;

   // system tray icon stuff
   HMainIcon:=LoadIcon(MainInstance, mainIcon);
   Shell_NotifyIcon(NIM_DELETE, @TrayIcon);
   with trayIcon do
   begin
      cbSize              := sizeof(TNotifyIconData);
      Wnd                 := handle;
      uID                 := 123;
      uFlags              := NIF_MESSAGE or NIF_ICON or NIF_TIP;
      uCallbackMessage    := WM_NOTIFYICON;
      hIcon               := HMainIcon;
      szTip               := 'Pheedstorm'
   end;
   Application.OnMinimize:= MinimizeClick;

   linkLabel := TLinkLabel.create(self);
   with linkLabel do
   begin
      parent := pnlHyperlink;
      top := 10;
      left := 10;
      visitedColor := clBlue;
      show;
   end;

   initialised := false;
   shownWelcome := false;
   Application.HintHidePause := 30000; // how long hints should be shown for
   proxyDetails := TIdProxyConnectionInfo.Create;

   setLength(articles, 0);
   lastUserInteraction := CurrentTimeMillis;
   downloadDir := ExtractFilePath(Application.ExeName) + 'temp';
   dataDir := ExtractFilePath(Application.ExeName) + 'data';
   articlesDir := ExtractFilePath(Application.ExeName) + 'articles';
   forceDirectories(downloadDir);
   forceDirectories(dataDir);
   forceDirectories(dataDir + '\backup');
   forceDirectories(articlesDir);
   urlsShownRecently := TCompMap.create;
   urlsShownRecentlyChanged := false;
   relevantWords := TShortIntMap.create;
   relevantWordsChanged := false;
   commonWords := TStringList.create;
   commonWords.Sorted := true;
   commonWords.CaseSensitive := false;

   sgArticles.Cells[COLUMN_TITLE,0] := 'Title';
   sgArticles.Cells[COLUMN_REASON,0] := 'Reason';
   sgArticles.Cells[COLUMN_USER_RATING,0] := 'Your rating';
   sgArticles.Cells[COLUMN_READ,0] := 'Read';
   sgArticles.Cells[COLUMN_TIMESTAMP,0] := 'Timestamp';

   // load config etc.
   confFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + '\' + confFileName);
   try
      loadConfig(confFile);

      if confFile.readString('main','checkForNewVersion','true') = 'true' then
      begin
         frmSplashScreen.updateDetails('Checking for new version',0);
         try
            if checkForNewVersion(mainWuulHost + 'pheedstorm/pheedstorm.xml', proxyDetails, StrToFloat(appVersion)) then
            begin
               if MessageDlg('A newer version of this program is available.  Do you want to visit the web site now so you can download the most recent version?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
                  ShellExecute(GetDesktopWindow, 'open', PChar(mainWuulHost + 'pheedstorm/readme.html'), nil, nil, SW_ShowNormal)
            end;
         except
            ShowMessage('Unable to check for new version.' + chr(13)+chr(10) + chr(13)+chr(10) + 'The site may be down, or there could be a problem with your internet connection.');
         end;
      end;

   finally
      confFile.free;
   end;

   loadKeptArticles;

   mainThread := TMainThread.create(self);
   mainThread.FreeOnTerminate := true;
   mainThread.resume;

   {register for drag and drop from external apps - this is so that we can drag an RSS icon from Internet Explorer}
   OleInitialize(nil) ;
   dropTarget := TDropTarget.create(self);
   OleCheck(RegisterDragDrop(frmFeeds.txtAddFeedUrl.Handle, DropTarget));
   OleCheck(RegisterDragDrop(frmFeeds.lbFeeds.Handle, DropTarget));
   OleCheck(RegisterDragDrop(application.Handle, DropTarget));
   OleCheck(RegisterDragDrop(self.Handle, DropTarget));

   initialised := true;

   frmSplashScreen.hide;
   // frmSplashScreen.free;

   // if a feed was passed in as a command-line parameter, subscribe to it:
   cmdLineArgs := getArgs;
   if length(cmdLineArgs) > 0 then
   begin
      subscribeToFeed(cmdLineArgs);
   end;
end;


procedure TfrmMain.subscribeToFeed(args: string);
begin
   Application.Restore;  {restore the application}
   Application.BringToFront;
   if WindowState = wsMinimized then WindowState := wsNormal;  {Reset minimized state}

   frmFeeds.show;
   frmFeeds.BringToFront;

   frmFeeds.txtAddFeedURL.Text := args;
   frmFeeds.btnAddFeedClick(self);
end;


procedure TfrmMain.loadKeptArticles;
var
  searchResult : TSearchRec;
  item: TItem;
  f: textfile;
  tmpStr: string;
begin
   if FindFirst(articlesDir + '\*.*', 0, searchResult) = 0 then
   begin
      try
         repeat
            mainThread.cleanItem(item);
            try
               AssignFile(f, articlesDir + '\' + searchResult.Name);
               reset(f);
               with item do
               begin
                  uniqueId := searchResult.Name;
                  readln(f, link);
                  readln(f, title);
                  readln(f, header);
                  readln(f, description);
                  description := StringReplace(description, CR, chr(13), [rfReplaceAll, rfIgnoreCase]);
                  description := StringReplace(description, LF, chr(10), [rfReplaceAll, rfIgnoreCase]);
                  readln(f, imageUrl);
                  readln(f, relevanceRatingFromHistory);
                  readln(f, RelevanceRatingFromUser);
                  timestamp := Now;
                  if StrToFloat(appVersion) >= 2.08 then
                  begin
                     readln(f, tmpStr);
                     if tmpStr <> '' then
                        timeStamp := StrToDateTime(tmpStr);
                  end;
                  closefile(f);
                  savedToDisk := true;
                  keep := true;
                  read := true;
                  //header := 'Saved article, relevance=' + IntToStr(relevanceRatingFromHistory) + '%';
               end;
               setLength(articles, length(articles)+1);
               articles[length(articles)-1] := item;
            except
               on e:exception do
               begin
                  showmessage('Error loading kept article ' + searchResult.Name + ' - ' + e.ClassName + ': ' + e.Message);
               end;
            end;
         until FindNext(searchResult) <> 0;
      finally
         FindClose(searchResult);
      end;
   end;

   sortItems;
   frmMain.displayItems;
end;

procedure TfrmMain.ClickTrayIcon(var msg: TMessage);
begin
  case msg.lparam of
    WM_LBUTTONUP, WM_LBUTTONDBLCLK :
    {WM_BUTTONDOWN may cause next Icon to activate if this icon is deleted -
        (Icons shift left and left neighbor will be under mouse at ButtonUp time)}
    begin
      Application.Restore;  {restore the application}
      If WindowState = wsMinimized then WindowState := wsNormal;  {Reset minimized state}
      {Added 5/6/04 ====>} visible:=true;
      SetForegroundWindow(Application.Handle); {Force form to the foreground }
      Shell_NotifyIcon(NIM_Delete, @TrayIcon);
    end;
  end;
end;

procedure TfrmMain.Config1Click(Sender: TObject);
begin
   frmFeeds.show;
end;

procedure TfrmMain.Markallread1Click(Sender: TObject);
begin
   markAllSelectedRead(true);
end;

procedure TfrmMain.Markallunread1Click(Sender: TObject);
begin
   markAllSelectedRead(false);
end;

procedure TfrmMain.markAllSelectedRead(read: boolean);
var
   i: integer;
begin
   for i := 0 to length(articlesDisplayed)-1 do
      articlesDisplayed[i].read := read;

   displayItems;
end;

procedure TfrmMain.keepAllSelected(keep: boolean);
var
   i: integer;
begin
   for i := 0 to length(articlesDisplayed)-1 do
   begin
      if (keep) and (not articlesDisplayed[i].keep) then
      begin
         articlesDisplayed[i].keep := true;
         articlesDisplayed[i].savedToDisk := false;
      end
      else if (not keep) then
      begin
         articlesDisplayed[i].keep := false;
      end;
   end;
   
   displayItems;
end;

procedure TfrmMain.MinimizeClick(Sender:TObject);
begin
   if not initialised then exit;
   HMainIcon := LoadIcon(MainInstance, mainIcon);
   trayIcon.hIcon := HMainIcon;
   Shell_NotifyIcon(NIM_Add, @TrayIcon);
   hide;
   {hide the taskbar button}
   if IsWindowVisible(Application.Handle) then
      ShowWindow(Application.Handle, SW_HIDE);
end;


procedure TfrmMain.Newsticker1Click(Sender: TObject);
begin
   if frmNewsTicker <> nil then
   begin
      frmNewsTicker.show;
   end
   else
   begin
      frmNewsTicker := TfrmNewsTicker.create(self);
      frmNewsTicker.show;
   end;
end;


procedure TfrmMain.freeNewsTicker;
begin
   FreeAndNil(frmNewsTicker);
end;

procedure TfrmMain.bringApplicationToFront(forceToForeground: boolean);
begin
   // beep;
   Application.Restore;
   visible := true;
   if isIconic(application.handle) then
      Shell_NotifyIcon(NIM_Delete, @TrayIcon);

   if forceToForeground then
   begin
      SetForeGroundWindow(Application.Handle);
      Application.BringToFront;
      ForceForegroundWindow(application.handle);
   end
   else
      FlashTaskbar;
end;

procedure TfrmMain.loadConfig(confFile: TIniFile);
var
   feedCount,keywordSetCount,i: integer;
   storedKeywords: string;
   configAppVersion: extended;
begin
   frmSplashScreen.updateDetails('Loading config...',0);

   // proxy config
   proxyDetails.ProxyServer := confFile.ReadString('main','proxyHost','');
   proxyDetails.ProxyPort := confFile.ReadInteger('main','proxyPort',0);
   proxyDetails.ProxyUsername := confFile.ReadString('main','proxyUsername','');
   proxyDetails.ProxyPassword := confFile.ReadString('main','proxyPassword','');
   proxyDetails.BasicAuthentication := confFile.readString('main','proxyBasicAuthentication','true') = 'true';

   // other config
   repeatInterval := confFile.readInteger('main','repeatInterval', 60) * MINUTE;
   verboseOutput := confFile.readString('main','verboseOutput','false') = 'true';
   alertMechanism := confFile.readInteger('main','alertMechanism',ALERT_CHANGEICON);
   runAfterIdleFor := confFile.readInteger('main','runAfterIdleFor',0) * 1000;
   firstTime := confFile.readString('main','firstTime','false') = 'true';
   backupDataFiles  := confFile.readString('main','backupDataFiles','true') = 'true';
   configAppVersion := StrToFloat(confFile.readString('main','appVersion',appVersion));
   // maxDownloadsPerDay := confFile.readInteger('main','maxDownloadsPerDay', 0);

   speakTitles := confFile.readString('main','speakTitles','false') = 'true';
   speakArticles := confFile.readString('main','speakArticles','false') = 'true';

   // count number of feeds and keyword sets
   feedCount := confFile.readInteger('rss','feedCount',0);
   keywordSetCount := confFile.readInteger('main','keywordSetCount',0);

   // create array & read keyword sets into it
   setLength(keywordSetList, keywordSetCount);
   for i := 0 to keywordSetCount-1 do
   begin
      frmSplashScreen.updateDetails('Loading keyword sets...',((i+1) * 100) div keywordSetCount);
      keywordSetList[i].name := confFile.ReadString('main','keywordSet.' + IntToStr(i) + '.name','');
      storedKeywords := StringReplace(confFile.ReadString('main','keywordSet.' + IntToStr(i) + '.keywords',''), 'CRLF', chr(13)+chr(10), [rfReplaceAll, rfIgnoreCase]);
      keywordSetList[i].keywords := parseString(storedKeywords,chr(13)+chr(10));
   end;

   // create array & read feeds into it
   setLength(feedsList, feedCount);
   for i := 0 to feedCount-1 do
   begin
      frmSplashScreen.updateDetails('Loading feeds...',((i+1) * 100) div feedCount);
      feedsList[i].url := confFile.ReadString('rss','feed.' + IntToStr(i) + '.url','');
      feedsList[i].active := confFile.ReadBool('rss','feed.' + IntToStr(i) + '.active',true);
      feedsList[i].showAllArticles := confFile.ReadBool('rss','feed.' + IntToStr(i) + '.showAllArticles',false);
      if configAppVersion < 1.4 then
      begin
         feedsList[i].keywordSets := TStringList.Create;
         feedsList[i].keywordSets.add('keywordset_' + IntToStr(i));
      end
      else
      begin
         storedKeywords := StringReplace(confFile.ReadString('rss','feed.' + IntToStr(i) + '.keywordSets',''), 'CRLF', chr(13)+chr(10), [rfReplaceAll, rfIgnoreCase]);
         feedsList[i].keywordSets := parseString(storedKeywords,chr(13)+chr(10));
      end;
      feedsList[i].refreshInterval := confFile.ReadInteger('rss','feed.' + IntToStr(i) + '.refreshInterval',defaultRefreshInterval);
      feedsList[i].lastRefresh := StrToFloat(confFile.ReadString('rss','feed.' + IntToStr(i) + '.lastRefresh','0'));
      frmFeeds.lbFeeds.Items.Add(feedsList[i].url);
   end;

   if length(feedsList) > 0 then
   begin
      frmFeeds.lbFeeds.ItemIndex := 0;
      frmFeeds.lbFeeds.OnClick(self);
   end;

   lastSavedData := CurrentTimeMillis;

    // other props
   minWordLength := confFile.ReadInteger('main','minWordLength',4);
   maxWordLength := confFile.ReadInteger('main','maxWordLength',12);
   maxWordWeight := confFile.ReadInteger('main','maxWordWeight',300);
   assert(maxWordWeight <= high(relType));
   saveDataInterval := confFile.ReadInteger('main','saveDataInterval',10) * MINUTE;

   fontSize := confFile.ReadInteger('main','fontSize',8);
   sgArticles.Canvas.font.size := fontSize;
   sgArticles.DefaultRowHeight := round(sgArticles.Canvas.TextHeight('I') * (1.5));
   txtContents.font.size := fontSize;

   // load the list of urls we have shown to the user
   urlsShownRecently.loadFromFile(dataDir + '\' + shownUrlsFile);

   // common words - these are ignored when doing relevance scans
   commonWords.LoadFromFile(dataDir + '\commonwords.dat');

   // other props
   frmFeeds.tbShowRelevance.position := confFile.ReadInteger('main','showRelevance',30);

   showImages := confFile.ReadString('main', 'showImages','true') = 'true';
   frmFeeds.cbShowImages.checked := showImages;
   setLinkPanelHeight;

   continuousScan := confFile.ReadString('main', 'continuousScan','true') = 'true';
   frmFeeds.cbContinuousScan.checked := continuousScan;

   resetUnreadArticlesOnExit := confFile.ReadString('main', 'resetUnreadArticlesOnExit','false') = 'true';
   frmFeeds.cbResetUnreadArticlesOnExit.Checked := resetUnreadArticlesOnExit;

   // debugging options
   downloadFeeds := confFile.ReadString('main', 'downloadFeeds','true') = 'true';
   downloadImages := confFile.ReadString('main', 'downloadImages','true') = 'true';
   saveXml := confFile.ReadString('main', 'saveXml','false') = 'true';

   // load list of word weightings
   frmSplashScreen.updateDetails('Loading word weightings...',0);
   loadWordWeightingsTable(dataDir + '\' + wordWeightingsFile);

   // load word relationship table
   setLength(wordLinks, 0);
   if relevantWords.count > 0 then
   begin
      // check for old relationship table (from previous versions)
      if FileExists(dataDir + '\' + oldRelTableFile) then
      begin
         loadOldRelTable(dataDir + '\' + oldRelTableFile);
      end
      else
      begin
         if FileExists(dataDir + '\' + linksTableFile) then
            loadLinksTable;
      end;
   end;

   // remove any words not in clean words list
   // as this list may have been improved since data was saved
   /// DON'T REALLY NEED THIS NOW
   // cleanData;

   frmSplashScreen.Hide;

   testProxy;
end;

{checks that the proxy connection is ok by downloading Google's home page
if an error occurs, give user chance to clear proxy settings & try direct connection}
procedure TfrmMain.testProxy;
begin
   if proxyDetails.ProxyServer = '' then exit;

   try
      getWebPageAsString('http://www.google.com/', proxyDetails);

   except
      on e:exception do
      begin
         if MessageDlg('Proxy settings appear to be invalid.  Use direct connection?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         begin
            with proxyDetails do
            begin
               ProxyServer := '';
               ProxyPort := 0;
               ProxyUsername := '';
               ProxyPassword := '';
               BasicAuthentication := true;
            end;
         end;
      end;
   end;
end;

procedure TfrmMain.setLinkPanelHeight;
begin
   image1.Visible := showImages;
   if showImages then
      frmMain.pnlHyperlink.Height := 120
   else
      frmMain.pnlHyperlink.Height := pnlTopHeader.Height;
end;
(*
procedure TfrmMain.Save2DShortArray(const A: T2DRelTypeArray; filename: string);
var
  writer: TWriter;
  i: Integer;
  fs: TFileStream;
begin
   fs := TFileStream.create(filename,fmCreate);
   try
     writer := TWriter.Create(fs, 8096);
     try
       writer.WriteInteger(Length(A));
       for i := 0 to Length(A) - 1 do
       begin
         writer.WriteInteger(Length(A[i]));
         writer.Write(A[i, 0], Length(A[i]) * sizeof(A[i, 0]));
       end;
     finally
       writer.Free;
     end;
    finally
      fs.free;
   end;
end;
*)

{purely provided to load and convert the legacy word relationship table}
procedure TfrmMain.Load2DShortArray(var A: T2DRelTypeArray; filename: string);
var
  reader: TReader;
  i, numrows, numcols: Integer;
  fs: TFileStream;
begin
   fs := TFileStream.create(filename,fmOpenRead);
   try
     reader := TReader.Create(fs, 8096);
     try
       numrows := reader.ReadInteger;
       SetLength(A, numrows);
       for i := 0 to numrows - 1 do
       begin
         frmSplashScreen.updateDetails('Loading ' + ExtractFileName(filename),i,numrows,10);
         numcols := reader.ReadInteger;
         SetLength(A[i], numcols);
         reader.Read(A[i, 0], numcols * sizeof(A[i, 0]));
       end;
     finally
       reader.Free;
     end;
   finally
      fs.free;
      frmSplashScreen.updateDetails('Loading ' + ExtractFileName(filename),100);
      frmSplashScreen.Hide;
   end;
end;


procedure TfrmMain.btnFirstClick(Sender: TObject);
begin
   sgArticles.Row := 1;
end;

procedure TfrmMain.btnLastClick(Sender: TObject);
begin
   sgArticles.Row := sgArticles.RowCount - 1;
end;

procedure TfrmMain.btnNextClick(Sender: TObject);
begin
   if sgArticles.Row < sgArticles.Rowcount-1 then
      sgArticles.Row := sgArticles.Row + 1;
end;

procedure TfrmMain.sortItemList(var itemsToSort: Items);
var
   tmp: TItem;
   i,j: integer;
begin
   for i := 0 to length(itemsToSort) - 1 do
   begin
      for j := 0 to length(itemsToSort) - 1 do
      begin
         if itemsToSort[i].relevanceRatingFromHistory >  itemsToSort[j].relevanceRatingFromHistory then
         begin
            tmp := itemsToSort[i];
            itemsToSort[i] := itemsToSort[j];
            itemsToSort[j] := tmp;
         end;
      end;
   end;
end;


{loads the word weightings table from a file}
procedure TfrmMain.loadWordWeightingsTable(filename: string);
var
   i,r: integer;
begin
   relevantWords.loadFromFile(filename);

   // ensure all words are within min/max range
   for i := 0 to relevantWords.count-1 do
   begin
      r := relevantWords.getValueAt(i);
      if r > maxWordWeight then
         relevantWords.setValueAt(i,maxWordWeight)
      else if r < 0-maxWordWeight then
         relevantWords.setValueAt(i,0-maxWordWeight);
   end;
end;


{loads the word relationship table from a file}
function TfrmMain.loadOldRelTable(filename: string): boolean;
var
   i,j: integer;
   tmpRelTable: T2DRelTypeArray;
begin
   result := false;
   if not FileExists(filename) then exit;

   try
      Load2DShortArray(tmpRelTable, filename);

      // check length is the same as the relevant words table
      if (length(tmpRelTable) = relevantWords.count) and
         (length(tmpRelTable[relevantWords.count-1]) = relevantWords.count) then

         result := true;

      // create new array of links from the old reltable
      for i := 0 to length(tmpRelTable) - 1 do
      begin
         for j:= 0 to length(tmpRelTable) - 1 do
         begin
            if i = j then continue;
            if tmpRelTable[i,j] = 0 then continue;
            setLength(wordLinks, length(wordLinks)+1);
            with wordLinks[length(wordLinks)-1] do
            begin
               word1 := i;
               word2 := j;
               strength := tmpRelTable[i,j];
            end;
         end;
      end;

      dumpLinkTable;
         
   except
      on e:exception do
      begin
         log(e.ClassName + ': ' + e.Message,false);
      end;
   end;
end;


{loads the word link table from a file}
procedure TfrmMain.loadLinksTable;
var
   f: textfile;
   lineCount,i,p1,p2: integer;
   line: string;
begin
   AssignFile(f, dataDir + '\' + linksTableFile);
   reset(f);

   // first pass over the file to count the lines
   lineCount := 0;
   while not eof(f) do
   begin
      readln(f, line);
      inc(lineCount);
   end;

   // now read the link data into the array
   setLength(wordLinks, lineCount);
   reset(f);
   for i := 0 to lineCount-1 do
   begin
      readln(f, line);
      p1 := pos(',',line);
      with wordLinks[i] do
      begin
         word1 := StrToInt(copy(line, 1, p1-1));
         p2 := pos('=',line);
         word2 := StrToInt(copy(line, p1+1, p2-p1-1));
         strength := StrToInt(copy(line, p2+1, length(line)-p1-1));
      end;
      frmSplashScreen.updateDetails('Loading ' + linksTableFile,i,lineCount,10);
   end;

   closefile(f);
   frmSplashScreen.hide;
end;


{this just saves stuff like the last time a feed was scanned}
procedure TfrmMain.saveUpdatedConfig;
var
   i: integer;
   confFile: TIniFile;
begin
   saveLock.Enter;
   try
      frmSplashScreen.updateDetails('Saving updated config...',0);
      log('Saving updated config...',false);
      Screen.Cursor := crHourglass;
      frmFeeds.cbCommonIntervals.Visible := false;
      confFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + '\' + confFileName);
      try
         for i := 0 to length(feedsList)-1 do
         begin
            frmSplashScreen.updateDetails('Saving feeds...',((i+1) * 100) div length(feedsList));
            if (feedsList[i].lastRefresh = 0) or (feedsList[i].lastRefresh > appStartTime) then
               confFile.WriteString(iniPrefix,'feed.' + IntToStr(i) + '.lastRefresh', FloatToStr(feedsList[i].lastRefresh));
         end;

         // other props
         confFile.WriteString('main','appVersion',appVersion);
         confFile.WriteString('main','firstTime','false');

         log('Finished saving updated config...',false);
      finally
         confFile.free;
         frmSplashScreen.Hide;
         Screen.Cursor := crDefault;
      end;
   finally
      saveLock.leave;
   end;
end;


{this saves the entire config including all feeds, keywords etc.}
procedure TfrmMain.saveAllConfig;
var
   i: integer;
   storedKeywords: string;
   confFile: TIniFile;
begin
   saveLock.Enter;
   try
      frmSplashScreen.updateDetails('Saving config...',0);
      log('Saving config...',false);
      Screen.Cursor := crHourglass;
      frmFeeds.cbCommonIntervals.Visible := false;
      confFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + '\' + confFileName);
      try
         for i := 0 to length(feedsList)-1 do
         begin
            frmSplashScreen.updateDetails('Saving feeds...',((i+1) * 100) div length(feedsList));
            confFile.WriteString(iniPrefix,'feed.' + IntToStr(i) + '.url', feedsList[i].url);
            confFile.WriteBool(iniPrefix,'feed.' + IntToStr(i) + '.active', feedsList[i].active);
            confFile.WriteBool(iniPrefix,'feed.' + IntToStr(i) + '.showAllArticles', feedsList[i].showAllArticles);
            storedKeywords := unparseString(feedsList[i].keywordSets,chr(13)+chr(10));
            confFile.WriteString(iniPrefix,'feed.' + IntToStr(i) + '.keywordSets', StringReplace(storedKeywords, chr(13)+chr(10), 'CRLF', [rfReplaceAll, rfIgnoreCase]));
            confFile.WriteInteger(iniPrefix,'feed.' + IntToStr(i) + '.refreshInterval', feedsList[i].refreshInterval);
            confFile.WriteString(iniPrefix,'feed.' + IntToStr(i) + '.lastRefresh', FloatToStr(feedsList[i].lastRefresh));
         end;

         confFile.WriteInteger('rss','feedCount',length(feedsList));

         // other props
         confFile.WriteString('main','appVersion',appVersion);
         confFile.WriteString('main','firstTime','false');
         confFile.WriteInteger('main','showRelevance',frmFeeds.tbShowRelevance.position);

			if frmFeeds.cbShowImages.checked then
         	confFile.WriteString('main','showImages','true')
			else
				confFile.WriteString('main','showImages','false');

         if frmFeeds.cbContinuousScan.checked then
				confFile.WriteString('main','continuousScan','true')
			else
				confFile.WriteString('main','continuousScan','false');

         if frmFeeds.cbResetUnreadArticlesOnExit.Checked then
            confFile.WriteString('main','resetUnreadArticlesOnExit','true')
			else
				confFile.WriteString('main','resetUnreadArticlesOnExit','false');


         // keyword sets
         confFile.WriteInteger('main','keywordSetCount',length(keywordSetList));
         for i := 0 to length(keywordSetList)-1 do
         begin
            confFile.WriteString('main','keywordSet.' + IntToStr(i) + '.name', keywordSetList[i].name);
            storedKeywords := unparseString(keywordSetList[i].keywords,chr(13)+chr(10));
            confFile.WriteString('main','keywordSet.' + IntToStr(i) + '.keywords', StringReplace(storedKeywords, chr(13)+chr(10), 'CRLF', [rfReplaceAll, rfIgnoreCase]));
         end;
         log('Finished saving config...',false);
      finally
         confFile.free;
         frmSplashScreen.Hide;
         Screen.Cursor := crDefault;
      end;
   finally
      saveLock.leave;
   end;
end;


{saves the data i.e. word weightings, relationships etc}
procedure TfrmMain.saveData;
begin
   saveLock.Enter;
   try
      log('Saving data...',false);
		if not savingFromThread then
      begin
         frmSplashScreen.updateDetails('Saving data...',0);
         Screen.Cursor := crHourglass;
      end;

      // save the list of urls we have shown to the user
      if urlsShownRecentlyChanged then
      begin
         if backupDataFiles then
         begin
            deleteFile(dataDir + '\backup\' + shownUrlsFile);
            moveFile(pchar(dataDir + '\' + shownUrlsFile),pchar(dataDir + '\backup\' + shownUrlsFile));
         end;
         urlsShownRecently.saveToFile(dataDir + '\' + shownUrlsFile);
         urlsShownRecentlyChanged := false;
      end;


      if relevantWordsChanged then
      begin
         // save the word weightings file
         if backupDataFiles then
         begin
            deleteFile(dataDir + '\backup\' + wordWeightingsFile);
            moveFile(pchar(dataDir + '\' + wordWeightingsFile),pchar(dataDir + '\backup\' + wordWeightingsFile));
         end;
         relevantWords.saveToFile(dataDir + '\' + wordWeightingsFile);

         // save the word links file
         if backupDataFiles then
         begin
            deleteFile(dataDir + '\backup\' + linksTableFile);
            moveFile(pchar(dataDir + '\' + linksTableFile),pchar(dataDir + '\backup\' + linksTableFile));
         end;
         saveLinksTable;

         relevantWordsChanged := false;
      end;

      // delete old relationship table, if it exists
      if FileExists(dataDir + '\' + oldRelTableFile) then DeleteFile(dataDir + '\' + oldRelTableFile);

      log('Finished saving data...',false);
      if not savingFromThread then
      begin
         frmSplashScreen.hide;
         Screen.Cursor := crDefault;
      end;
   finally
      saveLock.Leave;
   end;
end;


procedure TfrmMain.saveLinksTable;
var
   f: textfile;
   i: integer;
begin
   AssignFile(f, dataDir + '\' + linksTableFile);
   rewrite(f);
   for i := 0 to length(wordLinks)-1 do
   begin
      if not savingFromThread then
         frmSplashScreen.updateDetails('Saving ' + linksTableFile,i, length(wordLinks), 10);
      if wordLinks[i].strength <> 0 then
         writeln(f, IntToStr(wordLinks[i].word1) + ',' + IntToSTr(wordLinks[i].word2) + '=' + IntToStr(wordLinks[i].strength));
   end;
   closefile(f);
   if not savingFromThread then
      frmSplashScreen.Hide;
end;


procedure TfrmMain.cbKeepThisArticleClick(Sender: TObject);
begin
   if (not cellChanging) and (length(articles) > 0) and (sgArticles.Row > 0) then
   begin
      articlesDisplayed[sgArticles.Row-1]^.keep := cbKeepThisArticle.checked;
   end;
end;

procedure TfrmMain.cbRatedUnratedChange(Sender: TObject);
begin
   displayItems;
end;

procedure TfrmMain.cbShowKeptUnkeptChange(Sender: TObject);
begin
   displayItems;
end;

procedure TfrmMain.cbShowNewOldChange(Sender: TObject);
begin
   displayItems;
end;

procedure TfrmMain.cbShowReadUnreadChange(Sender: TObject);
begin
   displayItems;
end;

procedure TfrmMain.cleanData;
var
   i,j,k: integer;
   allWords: string;
   cleanWords: TStringList;
begin
   allWords := '';
   for i := 0 to relevantWords.count-1 do
      allWords := allWords + relevantWords.getKeyAt(i) + ' ';

   cleanWords := mainThread.getCleanWordList(allWords);
   try
      for i := relevantWords.count-1 downto 0 do
      begin
         frmSplashScreen.updateDetails('Checking data...',relevantWords.count - i + 1,relevantWords.count,10);
         if cleanWords.IndexOf(relevantWords.getKeyAt(i)) = -1 then
         begin
            // showmessage('removing ' + relevantWords.getKeyAt(i) + ', index ' + inttostr(i));
            relevantWords.delete(i);
            for j := length(wordLinks)-1 downto 0 do
            begin
               if (wordLinks[j].word1 = i) or (wordLinks[j].word2 = i) then
               begin
                  for k := j to length(wordLinks)-2 do
                     wordLinks[k] := wordLinks[k+1];
                  setLength(wordLinks, length(wordLinks)-1);
               end;
            end;
         end;
      end;
   finally
      cleanWords.free;
      frmSplashScreen.Hide;
   end;
end;


{returns the timestamp of the 20th newest article}
function TfrmMain.getOldArticleCutoffTime: TDateTime;
const
   newestArticlePos = 30;
var
   i,j: integer;
   sortedArticleTimestamps: array of TDateTime;
   tmp: TDateTime;
begin
   if length(articles) = 0 then
   begin
      result := Now;
      exit;
   end;

   // copy all article timestamps into temporary array
   setLength(sortedArticleTimestamps, length(articles));
   for i := 0 to length(sortedArticleTimestamps) -1 do
      sortedArticleTimestamps[i] := articles[i].timestamp;

   // sort by timestamp
   for i := 0 to length(sortedArticleTimestamps) -1 do
   begin
      for j := 0 to length(sortedArticleTimestamps) -1 do
      begin
         if sortedArticleTimestamps[i] > sortedArticleTimestamps[j] then
         begin
            tmp := sortedArticleTimestamps[i];
            sortedArticleTimestamps[i] := sortedArticleTimestamps[j];
            sortedArticleTimestamps[j] := tmp;
         end;
      end;
   end;

   // now return the timestamp at the required position
   result := sortedArticleTimestamps[min(newestArticlePos, length(sortedArticleTimestamps)-1)];
end;


{returns true if an item is already present in a list of items}
function TfrmMain.itemInList(var item:TItem; var itemList: Items): boolean;
var
   i: integer;
begin
   result := false;
   for i := 0 to length(itemList)-1 do
   begin
      if (itemList[i].title = item.title) or (itemList[i].link = item.link) then
      begin
         result := true;
         break;
      end;
   end;
end;


procedure TfrmMain.Keepall1Click(Sender: TObject);
begin
   keepAllSelected(true);
end;

{returns true if a URL was shown recently}
function TfrmMain.urlShownRecently(url: string): boolean;
var
   i: integer;
begin
   result := false;

   for i := urlsShownRecently.Count-1 downto 0 do
   begin
      // if url is old, remove it
      if CurrentTimeMillis - urlsShownRecently.getValueAt(i) > repeatInterval then
      begin
         urlsShownRecently.Delete(i);
         urlsShownRecentlyChanged := true;
      end
      else
      begin
         if url = urlsShownRecently.getKeyAt(i) then
         begin
            result := true;
            exit;
         end;
      end;
   end;
end;



procedure TfrmMain.Visitwebpage1Click(Sender: TObject);
begin
   ShellExecute(GetDesktopWindow, 'open', PChar(mainWuulHost + 'pheedstorm/readme.html'), nil, nil, SW_ShowNormal)
end;

procedure TfrmMain.btnSearchClick(Sender: TObject);
begin
   interrupted := true;
   displayItems;
end;

procedure TfrmMain.btnShowRelevanceClick(Sender: TObject);
var
   wordsList: TStringList;
   words: string;
begin
   Screen.Cursor := crHourglass;
   words := removehtml(sgArticles.Cells[COLUMN_TITLE,sgArticles.Row] + ' ' + txtContents.text,false);
   wordsList := mainThread.getCleanWordList(words);
   try
      showmessage('Simple relevance='+inttostr(mainThread.checkSimpleRelevance(wordsList))+'%, ' +
         'Relationship relevance='+inttostr(mainThread.checkRelevanceInRelTable(wordsList))+'%, ' +
         'Overall relevance='+inttostr(mainThread.checkRelevance(words))+'%');
   finally
      wordsList.free;
      Screen.Cursor := crDefault;
   end;
end;

procedure TfrmMain.btnPreviousClick(Sender: TObject);
begin
   if sgArticles.Row > 1 then
      sgArticles.Row := sgArticles.Row - 1;
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
   if (FirstTime) and (not shownHelp) then
   begin
      shownHelp := true;
      ShowMessage('To start you off some example RSS feeds have been pre-configured, and the program has been configured to show all articles regardless of their rating.  '+ chr(13)+chr(10) +
         'Try to rate as many articles as you can to enable the learning process to start working.'+ chr(13)+chr(10) + chr(13)+chr(10) +
         'Click the Config button to configure your feeds and set up keyword monitoring');
   end;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
   searchResult : TSearchRec;
   i,p,foundIndex: integer;

begin
   Screen.Cursor := crHourglass;

   // update any outstanding user ratings
   frmSplashScreen.updateDetails('Updating user ratings, please wait...',0);
   mainThread.updateUserRatings;
   frmSplashScreen.updateDetails('Updating user ratings, please wait...',100);

   // save any outstanding articles to keep
   frmSplashScreen.updateDetails('Saving articles, please wait...',0);
   mainThread.saveArticlesToKeep;
   frmSplashScreen.updateDetails('Saving articles, please wait...',100);

   frmFeeds.checkSaveConfig;
   
   // remove unread items from urlsShownRecently
   if resetUnreadArticlesOnExit then
   begin
      frmSplashScreen.updateDetails('Resetting unread articles, please wait...',0);
      for i := 0 to length(articles)-1 do
      begin
         with articles[i] do
         begin
            if not read then
            begin
               p := urlsShownRecently.indexOf(link);
               if p > -1 then
               begin
                  urlsShownRecently.delete(p);
                  urlsShownRecentlyChanged := true;
               end;
            end;
         end;
      end;
      frmSplashScreen.updateDetails('Resetting unread articles, please wait...',100);
   end;

   savingFromThread := false;
   saveUpdatedConfig;
   saveData;

   // delete downloaded files
   if (not runningWithinDelphiIDE) and (not saveXml) then
   begin
      frmSplashScreen.updateDetails('Deleting temporary files, please wait...',0);
      if FindFirst(downloadDir + '\*.*', 0, searchResult) = 0 then
      begin
         try
            repeat
               DeleteFile(downloadDir + '\' + searchResult.Name);
            until FindNext(searchResult) <> 0;
         finally
            FindClose(searchResult);
         end;
      end;
      frmSplashScreen.updateDetails('Deleting temporary files, please wait...',100);
   end;

   // delete any articles that are no longer marked as "kept"
   if FindFirst(articlesDir + '\*.*', 0, searchResult) = 0 then
   begin
      frmSplashScreen.updateDetails('Deleting old articles, please wait...',0);
      try
         repeat
            foundIndex := findArticleByUniqueId(searchResult.Name);
            if (foundIndex = -1) or (not articles[foundIndex].keep) then
            begin
               DeleteFile(articlesDir + '\' + searchResult.Name);
            end;
         until FindNext(searchResult) <> 0;
      finally
         FindClose(searchResult);
      end;
      frmSplashScreen.updateDetails('Deleting old articles, please wait...',100);
   end;
end;

function TfrmMain.getUniqueId: string;
begin
   inc(uniqueSeq);
   result := FloatToStr(currentTimeMillis+uniqueSeq);
end;

function TfrmMain.findArticleByUniqueId(id: string): integer;
var
   i: integer;
begin
   for i := 0 to length(articles) - 1 do
   begin
      if articles[i].uniqueId = id then
      begin
         result := i;
         exit;
      end;
   end;

   result := -1;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   // terminate thread, and wait until it has completely finished
   screen.cursor := crHourglass;
   frmSplashScreen.updateDetails('Closing, please wait...',0);
   interrupted := true;
   mainThread.terminate;
   while mainThread.isRunning do
   begin
      application.processmessages;
      sleep(500);
   end;
   frmSplashScreen.updateDetails('Closing, please wait...',100);
   CanClose := true;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
const
   hint = 'As you tell Pheedstorm how relevant you find each article, it will gradually learn about the kind of articles that interest you ' + chr(13) + chr(10) +
      ' and will start to show you similar articles in future.' + chr(13) + chr(10) +
      'The more feedback you provide, the more it will learn about your interests ' + chr(13) + chr(10) +
      'and the better it will get at showing you relevant content';
//var
   // Rect: TRect;
begin
   initialised := false;
   appStartTime := currentTimeMillis;
   imageSeq := 1;
   uniqueSeq := 0;
   saveLock := TCriticalSection.create;
   articleLock := TCriticalSection.create;

   pnlFeedback.Hint := hint;
   lblRateHeading.Hint := hint;
   lblIrrelevant.Hint := hint;
   lblTotallyRelevant.Hint := hint;
   gbRelevance.Hint := hint;


   updatingGrid := false;
   // SetRect(Rect, -1, -1, -1, -1);
   // sgArticles.Selection := TGridRect(Rect);
end;


procedure TfrmMain.dumpLinkTable;
var
   f: textfile;
   i: integer;
begin
   AssignFile(f, 'c:\temp\dump.txt');
   rewrite(f);
   for i := 0 to length(wordLinks)-1 do
      writeln(f, relevantWords.getKeyAt(wordLinks[i].word1) + ',' + relevantWords.getKeyAt(wordLinks[i].word2) + '=' + IntToStr(wordLinks[i].strength));
   closefile(f);
end;


procedure TfrmMain.Exit1Click(Sender: TObject);
begin
   close;
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   // note - form's "KeyPreview" must be set to true or this event isn't fired
   btnShowRelevance.visible := ((ssShift in Shift) and (ssAlt in Shift));
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
   sgArticles.ColWidths[COLUMN_TITLE] := sgArticles.Width div 2;
   sgArticles.ColWidths[COLUMN_REASON] := sgArticles.Width div 4;
   sgArticles.ColWidths[COLUMN_USER_RATING] := sgArticles.Width div 6;
   sgArticles.ColWidths[COLUMN_READ] := sgArticles.Width div 6;
   sgArticles.ColWidths[COLUMN_TIMESTAMP] := sgArticles.Width div 5;

   pnlUserRating.Left := (pnlBottomRight.width div 2) - (pnlUserRating.Width div 2);
end;

procedure TfrmMain.About1Click(Sender: TObject);
begin
   with TfrmAbout.create(self) do
   begin
      try
         caption := caption + ' ' + appVersion;
         label3.Caption := appVersion;
         ShowModal;
      finally
         free;
      end;
   end;
end;

procedure TfrmMain.addItems(var newItems: Items);
var
   i, oldSize: integer;
begin
   if length(newItems) = 0 then exit;

   articleLock.enter;
   try
      oldSize := length(articles);
      setLength(articles, oldSize + length(newItems));
      for i := 0 to length(newItems) - 1 do
         articles[oldSize+i] := newItems[i];
   finally
      articleLock.leave;
   end;
end;

procedure TfrmMain.alertUser;
begin
   if alertMechanism = ALERT_CHANGEICON then
      displayAlertIcon
   else if alertMechanism = ALERT_FLASHTASKBAR then
      bringApplicationToFront(false)
   else
      bringApplicationToFront(true);
end;

procedure TfrmMain.displayAlertIcon;
begin
   HMainIcon := LoadIcon(MainInstance, alertIcon);
   trayIcon.hIcon := HMainIcon;
   Shell_NotifyIcon(NIM_MODIFY, @TrayIcon);
end;


procedure TfrmMain.sortItems;
begin
   articleLock.enter;
   try
      sortItemList(articles);
   finally
      articleLock.leave;
   end;
end;

procedure TfrmMain.Unkeepall1Click(Sender: TObject);
begin
   keepAllSelected(false);
end;

procedure TfrmMain.displayItems;
var
   i: integer;
   displayItem: boolean;
   oldArticleCutoffTime: TDateTime;
   fulltext, currentSelectedItem: string;
begin
   articleLock.enter;
   updatingGrid := true;
   try
      if length(articles) = 0 then
      begin
         displayingSomeArticles(false);
         exit;
      end;

      oldArticleCutoffTime := getOldArticleCutoffTime;

      // save position of current selected article
      if sgArticles.Row > 0 then
         currentSelectedItem := sgArticles.Cells[COLUMN_TITLE, sgArticles.Row]
      else
         currentSelectedItem := '';

      // work out which articles to display
      setLength(articlesDisplayed, 0);
      for i := 0 to length(articles) - 1 do
      begin
         displayItem := true;

         if (cbShowReadUnread.ItemIndex = 1) and (not articles[i].read) then displayItem := false;
         if (cbShowReadUnread.ItemIndex = 2) and (articles[i].read) and (articles[i].title <> currentSelectedItem) then displayItem := false;

         if (cbShowNewOld.ItemIndex = 1) and (articles[i].timestamp < oldArticleCutoffTime) then displayItem := false;
         if (cbShowNewOld.ItemIndex = 2) and (articles[i].timestamp >= oldArticleCutoffTime) then displayItem := false;

         if (cbRatedUnrated.ItemIndex = 1) and (articles[i].relevanceRatingFromUser = 0) then displayItem := false;
         if (cbRatedUnrated.ItemIndex = 2) and (articles[i].relevanceRatingFromUser <> 0) then displayItem := false;

         if (cbShowKeptUnkept.ItemIndex = 1) and (not articles[i].keep) then displayItem := false;
         if (cbShowKeptUnkept.ItemIndex = 2) and (articles[i].keep) then displayItem := false;

         fullText := articles[i].link + ' ' + articles[i].title + ' ' + articles[i].description;
         if (length(txtSearch.Text) > 0) and (pos(uppercase(txtSearch.Text), uppercase(fulltext)) = 0) then displayItem := false;

         if displayItem then
         begin
            setLength(articlesDisplayed, length(articlesDisplayed)+1);
            articlesDisplayed[length(articlesDisplayed)-1] := @articles[i];
         end;
      end;

      sgArticles.RowCount := length(articlesDisplayed)+1;
      for i := 0 to length(articlesDisplayed) - 1 do
      begin
         sgArticles.Cells[COLUMN_TITLE,i+1] := removeHtml(articlesDisplayed[i]^.title, true);
         sgArticles.Cells[COLUMN_REASON,i+1] := articlesDisplayed[i]^.header;
         sgArticles.Cells[COLUMN_USER_RATING,i+1] := IntToStr(articlesDisplayed[i]^.relevanceRatingFromUser);
         if articlesDisplayed[i]^.read then
            sgArticles.Cells[COLUMN_READ,i+1] := 'Yes'
         else
            sgArticles.Cells[COLUMN_READ,i+1] := 'No';
         sgArticles.Cells[COLUMN_TIMESTAMP,i+1] := DateTimeToStr(articlesDisplayed[i]^.timestamp);
      end;

      if length(articlesDisplayed) = 0 then
      begin
         displayingSomeArticles(false);
         exit;
      end
      else
      begin
         displayingSomeArticles(true);
      end;

      // re-select the article previously selected
      if currentSelectedItem <> '' then
      begin
         for i := 0 to length(articlesDisplayed) - 1 do
         begin
            if articlesDisplayed[i]^.title = currentSelectedItem then
            begin
               sgArticles.Row := i+1;
               break;
            end;
         end;
      end;

      if sgArticles.Row < 1 then sgArticles.Row := 1;

   finally
      articleLock.Leave;
      updatingGrid := false;
   end;

   showArticle(sgArticles.Row-1);
end;


procedure TfrmMain.displayingSomeArticles(showingSome: boolean);
var
   rb: TRadioButton;
   i: integer;
begin
   cbKeepThisArticle.Enabled := showingSome;
   pnlUserRating.Enabled := showingSome;
   for i := 0 to gbRelevance.ControlCount - 1 do
   begin
      if gbRelevance.Controls[i].ClassType = TRadioButton then
      begin
         rb := (gbRelevance.Controls[i] as TRadioButton);
         rb.Enabled := showingSome;
      end;
   end;

   if not showingSome then
   begin
      txtContents.Clear;
      linkLabel.Caption := '';
      linkLabel.URL := '';
      setRelevance(0);
   end;
end;

procedure TfrmMain.RadioButton1Click(Sender: TObject);
begin
   if (not cellChanging) and (sgArticles.Row > 0) then
   begin
      if not articlesDisplayed[sgArticles.Row-1]^.reapplyRelevance then
         articlesDisplayed[sgArticles.Row-1]^.previousRelevanceRatingFromuser := articlesDisplayed[sgArticles.Row-1]^.relevanceRatingFromuser;
      articlesDisplayed[sgArticles.Row-1]^.relevanceRatingFromuser := getRelevance;
      articlesDisplayed[sgArticles.Row-1]^.reapplyRelevance := true;

      // if "keep", re-save article with new relevance
      if articlesDisplayed[sgArticles.Row-1]^.keep then articlesDisplayed[sgArticles.Row-1]^.savedToDisk := false;

      sgArticles.Cells[COLUMN_USER_RATING,sgArticles.Row] := IntToStr(articlesDisplayed[sgArticles.Row-1]^.relevanceRatingFromuser);
   end;
end;



procedure TfrmMain.Reset1Click(Sender: TObject);
begin
   if MessageDlg('Clear the list of viewed articles?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      urlsShownRecently.Clear;
      urlsShownRecentlyChanged := true;
      interrupted := true;
   end;
end;

procedure TfrmMain.Resetfeedlastscantimes1Click(Sender: TObject);
var
   i: integer;
begin
   if MessageDlg('Reset the time that feeds were last marked as scanned?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      for i := 0 to length(feedsList)-1 do
         feedsList[i].lastRefresh := 0;

      interrupted := true;
   end;
end;

procedure TfrmMain.sgArticlesDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
const
   clCyan = TColor($00FFFF00);
var
   str: string;
begin
   if ARow = 0 then
      sgArticles.Canvas.Brush.Color := clGray
   else if ARow = sgArticles.Row then
      sgArticles.Canvas.Brush.Color := clCyan
   else
      sgArticles.Canvas.Brush.Color := clWhite;

   sgArticles.Canvas.FillRect(Rect);

   sgArticles.Canvas.Font.Color := clBlack;
   if ARow > 0 then
   begin
      if (sgArticles.Cells[COLUMN_READ, ARow] = 'No') then
         sgArticles.Canvas.Font.Color := clRed;
   end;

   str := sgArticles.Cells[ACol, ARow];
   sgArticles.Canvas.TextOut(Rect.Left + 2, Rect.Top + 2, str);
end;

procedure TfrmMain.sgArticlesSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
   if (ARow > 0) and (length(articles) > 0) and (not updatingGrid) then
   begin
      sgArticles.Cells[COLUMN_READ, ARow] := 'Yes';
      showArticle(ARow-1);
   end;
end;


{returns the position of an item in the main list}
function TfrmMain.findArticleInMainList(var item: TItem): integer;
var
   i: integer;
begin
   result := -1;
   for i := 0 to length(articles)-1 do
   begin
      if articles[i].uniqueId = item.uniqueId then
      begin
         result := i;
         exit;
      end;
   end;
end;


procedure TfrmMain.showImage(imageFileName: string; width: integer; height: integer);
var
   jpg : TJpegImage;
   png: TPNGObject; // uses pngimage
   f : TFileStream;
   graphic : TOleGraphic; // uses axctrls
   imageFileExt: string;
begin
   imageFileExt := ExtractFileExt(imageFileName);
   if FileExists(imageFileName) then
   begin
      try
         image1.width := min(width,300);
         image1.height := min(height,300);
         if imageFileExt = '.JPG' then
         begin
            jpg := TJpegImage.Create();
            try
               jpg.LoadFromFile(imageFileName);
               image1.picture.assign(jpg);
            finally
               jpg.free;
            end;
         end
         else if imageFileExt = '.PNG' then
         begin
            png := TPNGObject.Create;
            try
               png.LoadFromFile(imageFileName);
               image1.picture.assign(PNG);
            finally
               png.free;
            end;
         end
         else if imageFileExt = '.GIF' then
         begin
            graphic := TOleGraphic.Create;
            try
               f := TFileStream.Create (imageFileName, fmOpenRead or fmShareDenyNone);
               try
                  graphic.LoadFromStream(f);
                  image1.Picture.Assign(graphic);
               finally
                  f.Free
               end;
            finally
               graphic.free;
            end;
         end
         else
            assert(false); // should never get here

         image1.Visible := true;
         pnlHyperlink.Height := image1.Height + 70;
      except
         on E:Exception do
            Log(E.ClassName + ' raised ' + E.Message + ' displaying ' + imageFileName,false);
      end;
   end
   else
   begin
      log('Image file does not exist: ' + imageFileName,false);
   end;

end;


procedure TfrmMain.showArticle(index: integer);
var
   imageFileName, imageFileExt: string;
begin
   articleLock.enter;
   try
      if index <= length(articlesDisplayed)-1 then
      begin
         articlesDisplayed[index]^.read := true;
         txtContents.Text := removeHtml(articlesDisplayed[index]^.description,true);
         linkLabel.Caption := articlesDisplayed[index]^.link;
         linkLabel.URL := articlesDisplayed[index]^.link;
         if (showImages) and (articlesDisplayed[index]^.imageNumber > 0) then
         begin
            imageFileExt := uppercase(ExtractFileExt(articlesDisplayed[index]^.imageUrl));
            imageFileName := downloadDir + '\image_' + IntToStr(articlesDisplayed[index]^.imageNumber) + imageFileExt;
            showImage(imageFileName, articlesDisplayed[index]^.imageWidth, articlesDisplayed[index]^.imageHeight);
         end
         else
         begin
            image1.Visible := false;
            pnlHyperlink.Height := pnlTopHeader.Height;
         end;
         cellChanging := true; // stop events firing
         setRelevance(articlesDisplayed[index]^.relevanceRatingFromUser);
         cbKeepThisArticle.checked := articlesDisplayed[index]^.keep;
         cellChanging := false;
      end
      else
      begin
         txtContents.Text := 'No article selected';
         linkLabel.Caption := '';
         linkLabel.URL := '';
      end;
   finally
      articleLock.Leave;
   end;
end;


function TfrmMain.getRelevance: integer;
var
   i: integer;
   rb: TRadioButton;
begin
   for i := 0 to gbRelevance.ControlCount - 1 do
   begin
      if gbRelevance.Controls[i].ClassType = TRadioButton then
      begin
         rb := (gbRelevance.Controls[i] as TRadioButton);
         if rb.Checked then
         begin
            result := rb.Tag;
            exit;
         end;
      end;
   end;
   assert(false); // should never get here
end;

procedure TfrmMain.setRelevance(relevance: integer);
var
   i: integer;
   rb: TRadioButton;
begin
   for i := 0 to gbRelevance.ControlCount - 1 do
   begin
      if gbRelevance.Controls[i].ClassType = TRadioButton then
      begin
         rb := (gbRelevance.Controls[i] as TRadioButton);
         if rb.tag = relevance then
         begin
            rb.Checked := true;
            exit;
         end;
      end;
   end;
   assert(false); // should never get here
end;


procedure TfrmMain.log(line: string; isVerbose: boolean);
begin
   if (not verboseOutput) and (isVerbose) then exit;
   frmMain.logEntry := line;
   logFromOtherThread;
end;


{must be called within "synchronise"}
procedure TfrmMain.logFromOtherThread;
begin
   if txtResults.Lines.Count > 10000 then txtResults.Clear;
   txtResults.Lines.Add(DateTimeToStr(Now) + ': ' + logEntry);
   SendMessage(txtResults.handle, EM_SCROLLCARET,0,0);
end;

{this is where another instance passes its command-line arguments}
procedure TfrmMain.WMCopyData(var Msg : TWMCopyData);
var
  params: string;
begin
   params := PChar(Msg.CopyDataStruct.lpData);
   subscribeToFeed(params);
   msg.Result := 1;
end;




{constructor}
constructor TMainThread.create(_frmOwner: TForm);
begin
   inherited create(true); // create but don't start running yet
   frmOwner := _frmOwner;
   isRunning := true;
end;

{destructor}
destructor TMainThread.Destroy;
begin
   inherited destroy;
end;


{main thread entry point}
procedure TMainThread.Execute;
var
   sleepPeriod, i: integer;
begin
   try
      CoInitialize(nil); // for "say" procedure

      //if runningWithinDelphiIDE then sleep(500000); // for testing, only applies when running in Delphi IDE

      repeat

         try

            try
               searchAll;
               if terminated then break;

               downloadOutstandingImages; // we do this here as well as after scanning a feed, as the user may have only just switched this on
               if terminated then break;

               updateUserRatings;
               if terminated then break;

               saveArticlesToKeep;
               if terminated then break;

               // save data at regular intervals
               if currentTimeMillis - lastSavedData > saveDataInterval then
               begin
                  savingFromThread := true;
                  synchronize(frmMain.SaveData);
                  lastSavedData := CurrentTimeMillis;
               end;

            except
               on e:exception do
               begin
                  if e.Message <> '' then
                     log(e.Message,false)
                  else
                     log(e.ClassName,false);
               end;
            end;

         finally
            if runningWithinDelphiIDE then
               sleepPeriod := 5
            else
               sleepPeriod := 30;

            interrupted := false;
            for i := 0 to sleepPeriod-1 do
            begin
               sleep(1000);
               if (interrupted) or (terminated) then break;
            end;

         end;

      until terminated;

      CoUnInitialize; // for "say" procedure

   finally
      isRunning := false;
   end;
end;

function TMainThread.isThreadRunning: boolean;
begin
   result := isRunning;
end;

{
function TMainThread.feedsDownloadedToday: integer;
var
   i: integer;
   last24hours: COMP;
begin
   last24hours := CurrentTimeMillis - (MINUTE * 60 * 24);
   result := 0;
   for i := 0 to length(feedsList)-1 do
   begin
      if (feedsList[i].lastRefresh > 0) and (feedsList[i].lastRefresh > last24Hours) then
      begin
         inc(result);
      end;
   end;
end;
}


procedure TMainThread.sortFeedsByLastRefreshTime;
var
   i,j: integer;
   tmpFeed: TFeed;
begin
   Screen.Cursor := crHourglass;
   for i := 0 to length(feedsList)-1 do
   begin
      for j := 0 to length(feedsList)-1 do
      begin
         if feedsList[i].lastRefresh > feedsList[j].lastRefresh then
         begin
            tmpFeed := feedsList[i];
            feedsList[i] := feedsList[j];
            feedsList[j] := tmpFeed;
         end;
      end;
   end;
   Screen.Cursor := crDefault;
end;


procedure TMainThread.searchAll;
var
   i: integer;
   matchingItems: Items;
begin
   if length(feedsList) = 0 then
   begin
      log('No feeds configured!  Use Config button',false);
      exit;
   end;

   // sort feeds so that the one that was refreshed the longest time ago
   // is at the top of the queue this time round
   // sortFeedsByLastRefreshTime;

   try

      log('Searching all active feeds',false);
      for i := 0 to length(feedsList)-1 do
      begin
         // ignore inactive feeds
         if not feedsList[i].active then
         begin
            log('Ignoring inactive feed ' + feedsList[i].url,false);
            continue;
         end;

         // stop if maxDownloadsPerDay already reached in past 24 hours
         // disabled for now as I'm not sure it's working properly
         // and am not convinced this is a good idea anyway
         {
         if (maxDownloadsPerDay > 0) and (feedsDownloadedToday >= maxDownloadsPerDay) then
         begin
            log(IntToStr(feedsDownloadedToday) + ' feeds downloaded in last 24 hours, not downloading anything at present',false);
            break;
         end;
         }

         // don't scan if scanned recently
         // unless continuousScan is on
         if not frmMain.continuousScan then
         begin
            if (currentTimeMillis - feedsList[i].lastRefresh < (feedsList[i].refreshInterval * 1000)) then
            begin
               log('Ignoring feed ' + feedsList[i].url + ' as scanned on ' + DateTimeToStr(javaTimeToTDateTime(feedsList[i].lastRefresh)),false);
               continue;
            end;
         end;

         // ensure PC is idle if required
         if LastWork < runAfterIdleFor then
         begin
            log('User is busy, waiting for idle...',false);
            frmMain.updateTrayIconText('Pheedstorm: Waiting for idle');
            waitForIdle(runAfterIdleFor);
         end;

         // get matching items for this feed and add to list of all matching items
         frmMain.updateTrayIconText('Pheedstorm: Scanning feed ' + IntToStr(i+1) + '/' + IntToStr(length(feedsList)) + ': ' + feedsList[i].url);
         setLength(matchingItems,0);
         scanFeed(feedsList[i],matchingItems);
         handleFoundItems(matchingItems);

         // don't scan any more feeds if shutting down
         if terminated then
         begin
            log('Thread terminated...', false);
            break;
         end;
      end;

      log('Finished searching active feeds',false);
   finally
      setLength(matchingItems,0);
      frmMain.updateTrayIconText('Pheedstorm');
   end;
end;



{scans a feed by downloading the XML document and starting the scan}
procedure TMainThread.scanFeed(var feed: TFeed; var listToAddTo:Items);
const
   RSS_START = 'ITEM';
   TITLE = 'TITLE';
   RSS_CONTENT = 'DESCRIPTION';
   ATOM_START = 'ENTRY';
   ATOM_CONTENT = 'CONTENT';
   LINK = 'LINK';
   RSS_IMAGE = 'MEDIA:THUMBNAIL';
   RSS_ENCLOSURE = 'ENCLOSURE';
   //ATOM_IMAGE = 'MEDIA:THUMBNAIL';
   ATOM_HREF = 'HREF';
var
   MyXml: TXmlParser;
   item: TItem;
   i: integer;
begin
   log('Scanning feed ' + feed.url,false);

   try
      if downloadFeeds then // prevent downloading for testing only
      begin
         if downloadFile(feed.url, tempFile, true, feed.lastRefresh) = NOT_DOWNLOADING then exit;
      end;
   finally
      feed.lastRefresh := currentTimeMillis;
   end;

   MyXml := TXmlParser.Create;
   try
      MyXml.LoadFromFile (downloadDir + '\' + tempFile);
      MyXml.StartScan;
      while MyXml.Scan do
      begin
         if uppercase(MyXml.CurName) = RSS_START then
         begin
            cleanItem(item);

            // RSS
            repeat
               //log(MyXml.CurContent, true);
               if not MyXml.Scan then break; // just in case
               if uppercase(MyXml.CurName) = TITLE then
                  item.title := MyXml.CurContent
               else if uppercase(MyXml.CurName) = RSS_CONTENT then
                  item.description := MyXml.CurContent
               else if uppercase(MyXml.CurName) = LINK then
                  item.link := MyXml.CurContent
               else if uppercase(MyXml.CurName) = RSS_IMAGE then
               begin
                  try
                     item.imageUrl := MyXml.CurAttr.Value('url');
                     if uppercase(copy(item.imageUrl, 1, 4)) <> 'HTTP'  then
                        item.imageUrl := getBaseUrl(feed.url) + item.imageUrl;
                     item.imageHeight := StrToInt(MyXml.CurAttr.Value('height'));
                     item.imageWidth := StrToInt(MyXml.CurAttr.Value('width'));
                  except
                     item.imageUrl := '';
                  end;
               end
               else if uppercase(MyXml.CurName) = RSS_ENCLOSURE then
               begin
                  // enclosures are really for embedding multimedia objects such as videos, mp3s etc
                  // but often contain images
                  try
                     item.imageUrl := MyXml.CurAttr.Value('url');
                     item.imageHeight := 50;
                     item.imageWidth := 100;
                  except
                     item.imageUrl := '';
                  end;
               end;
            until uppercase(MyXml.CurName) = RSS_START;
            log('End of article', true);
            doScan(feed,item,listToAddTo);
            log('Finished scanning article', true);
         end
         else if uppercase(MyXml.CurName) = ATOM_START then
         begin
            cleanItem(item);

            // ATOM
            repeat
               if not MyXml.Scan then break; // just in case
               if uppercase(MyXml.CurName) = TITLE then
                  item.title := MyXml.CurContent
               else if uppercase(MyXml.CurName) = ATOM_CONTENT then
                  item.description := MyXml.CurContent
               else if uppercase(MyXml.CurName) = LINK then
               begin
                  for i := 0 to MyXml.CurAttr.Count-1 do
                  begin
                     // log(MyXml.CurAttr.Name(i) + '=' + MyXml.CurAttr.Value(i));
                     if uppercase(MyXml.CurAttr.Name(i)) = ATOM_HREF then
                     begin
                        item.link := MyXml.CurAttr.Value(i);
                        break;
                     end;
                  end;
               {end
               else if uppercase(MyXml.CurName) = ATOM_IMAGE then
               begin
                  try
                     item.imageUrl := MyXml.CurAttr.Value('url');
                     item.imageHeight := StrToInt(MyXml.CurAttr.Value('height'));
                     item.imageWidth := StrToInt(MyXml.CurAttr.Value('width'));
                  except
                     item.imageUrl := '';
                  end;}
               end;
            until uppercase(MyXml.CurName) = ATOM_START;
            doScan(feed,item,listToAddTo);
         end;
      end;
   finally
      MyXml.Free;
   end;
   log('Finished scanning feed ' + feed.url,false);
end;


procedure TMainThread.cleanItem(var item: TItem);
begin
   with item do
   begin
      uniqueId := frmMain.getUniqueId;
      title := '';
      description := '';
      link := '';
      header := '';
      read := false;
      keep := false;
      savedToDisk := false;
      timestamp := Now;
      reapplyRelevance := false;
      relevanceRatingFromHistory := 0;
      relevanceRatingFromUser := 0;
	   previousRelevanceRatingFromUser := 0;
      imageNumber := 0; // indicates not downloaded
      imageUrl := '';
      imageDownloadAttempts := 0;
      imageHeight := 0;
      imageWidth := 0;
   end;
end;


{return result is an empty string if successful, or an error message if unsuccessful}
function TMainThread.downloadFile(url: string; downloadFileName: string; checkLastModified: boolean; lastRefresh: COMP): string;
var
   HTTP: TIdHTTP;
   Stream: TMemoryStream;
   localName: string;
   IdSSLIOHandlerSocket: TIdSSLIOHandlerSocketOpenSSL;
   isHttps: boolean;
begin
   log('Downloading ' + url + ' to ' + downloadFileName,true);
   result := '';
   isHttps := pos('HTTPS://', uppercase(url)) = 1;
   try
      url := urlencode(url);
      localName := downloadDir + '\' + downloadFileName;
      DeleteFile(localName);
      HTTP := TIdHTTP.Create(nil);

      if isHttps then
      begin
         idSSLIOHandlerSocket :=  TIdSSLIOHandlerSocketOpenSSL.create(nil);
         idSSLIOHandlerSocket.SSLOptions.Method := TIdSSLVersion(sslvSSLv23);
         HTTP.IOHandler := idSSLIOHandlerSocket;
      end;

      try
         with HTTP do
         begin
            with ProxyParams do
            begin
               ProxyServer := proxyDetails.ProxyServer;
               ProxyPort := proxyDetails.ProxyPort;
               ProxyUsername := proxyDetails.ProxyUsername;
               ProxyPassword := proxyDetails.ProxyPassword;
            end;
            HandleRedirects := True;
            AllowCookies := false;
            ReadTimeout := SOCKET_TIMEOUT;
            ConnectTimeout := SOCKET_TIMEOUT;
            Request.UserAgent := 'Mozilla/4.0';
            Request.Connection := 'Keep-Alive';
            Request.ProxyConnection := 'Keep-Alive';
            Request.CacheControl := 'no-cache';
         end;

         if checkLastModified then
         begin
            // don't download page if it hasn't been modified since the last download
            HTTP.Head(Url);
            if HTTP.Response.LastModified > 0 then
            begin
               if getDateDiffMills(HTTP.Response.LastModified, javaTimeToTDateTime(lastRefresh)) < 0 then
               begin
                  log(Url + ' last modified on ' + DateTimeToStr(HTTP.Response.LastModified) + ', lastRefresh=' + DateTimeToStr(javaTimeToTDateTime(lastRefresh)) + ' so not downloading', false);
                  result := NOT_DOWNLOADING;
                  exit;
               end;
            end;
         end;

         Stream := TMemoryStream.Create;
         try
            HTTP.Get(Url,Stream);
            Stream.SaveToFile(localName);
            log('Downloaded ' + url + ' ok',true);

            // save files for later analysis?
            if (saveXml) and (downloadFileName = tempFile) then
               copyFile(pchar(localName), pchar(downloadDir + '\' + FloatToStr(currentTimeMillis) + '.xml'), true);
         finally
            Stream.Free;
         end;
      finally
         HTTP.Free;
         if isHttps then idSSLIOHandlerSocket.free;
      end;

   except
      on e:exception do
      begin
         if e.Message <> '' then
            result := e.Message
         else
            result := e.ClassName;

         log('Error downloading ' + url + ': ' + result,false);
      end;
   end;
end;



{scans a feed for items from an article
we scan for keywords, then for relevance}
procedure TMainThread.doScan(var feed: TFeed; var item: TItem; var itemList: Items);
const
   maxArticleLength = 100000; // FIXME make configurable 
var
   cleanText: string;
   relevance: integer;
   matchResult: keywordScanResult;
begin
   // ignore any links that have already been shown
   if frmMain.urlShownRecently(item.link) then
   begin
      log('URL ' + item.link + ' has been shown recently, ignoring it',true);
      exit;
   end;

   // sanity check to stop a huge article crashing the entire app
   if length(item.description) > maxArticleLength then
      item.description := copy(item.description, 1, maxArticleLength) + '...[rest of article too big to display]';

   // clean up first
   cleanText := removeHtml(item.title + ' ' + item.description,false);

   // ignore any identical items already in this list or the full list
   if (frmMain.itemInList(item, itemList)) or (frmMain.itemInList(item, articles)) then
   begin
      log('Duplicate URL ' + item.link + ' found, ignoring it',true);
      exit;
   end;

   // if all articles should be shown for this feed, include the article
   if feed.showAllArticles then
   begin
      item.header := 'New article';
      log(item.header + ' = ' + item.title, false);
      item.relevanceRatingFromHistory := 100;
      setLength(itemList, length(itemList)+1);
      itemList[length(itemList)-1] := item;
      exit;
   end;

   // do keyword search first (title and description)
   matchResult := scanKeywords(feed,cleanText);

   // if no keyword matches, search on overall relevance
   if matchResult.matchCount > 0 then
   begin
      item.header := 'Keyword: ' + matchResult.matchingKeywords;
      log(item.header, false);
      item.relevanceRatingFromHistory := 100 + matchResult.matchCount;
      setLength(itemList, length(itemList)+1);
      itemList[length(itemList)-1] := item;
   end
   else
   begin
      relevance := checkRelevance(cleanText);
      if relevance >= frmFeeds.tbShowRelevance.position then
      begin
         item.header := 'Article found, relevance=' + IntToStr(relevance) + '%';
         log(item.header, false);
         item.relevanceRatingFromHistory := relevance;
         setLength(itemList, length(itemList)+1);
         itemList[length(itemList)-1] := item;
      end;
   end;
end;

{handles results from a search}
procedure TMainThread.handleFoundItems(var matchingItems: Items);
var
   i: integer;
begin
   if length(matchingItems) = 0 then
   begin
      log('No new matching items found',false);
      if firstTime then
      begin
         log('You may want to consider lowering the alert threshold by using the slider on the top right, it is currently set to only show articles with a relevance of at least ' + IntToStr(frmFeeds.tbShowRelevance.position) + '%.'+chr(13)+chr(10)+
         'You should also rate as many articles as you can - the more times you do this, the more the program will learn about the type of content that interests you',false);
      end;
      exit;
   end;

   for i := 0 to length(matchingItems)-1 do
   begin
      // add URL to list of recently shown URLs
      // this means we won't show it again for a while
      urlsShownRecently.put(matchingItems[i].link,CurrentTimeMillis);
      urlsShownRecentlyChanged := true;
   end;

   // add new items to list of articles
   frmMain.addItems(matchingItems);

   // download any images if user has enabled this
   // FOR SOME WEIRD REASON LOADING IMAGES HERE CAUSES ACCESS VIOLATIONS
   // if frmMain.showImages then downloadOutstandingImages;

   // sort & display results
   frmMain.sortItems;
   synchronize(frmMain.displayItems);

   // download any images if user has enabled this
   // FOR SOME WEIRD REASON LOADING IMAGES HERE IS OK
   if frmMain.showImages then downloadOutstandingImages;

   // alert user by changing the icon
   synchronize(frmMain.alertUser);

   for i := 0 to length(matchingItems)-1 do
   begin
      try
         if speakTitles then say(matchingItems[i].title);
         if speakArticles then say(matchingItems[i].description);
      except
         // causes Floating point division by zero on Vista - no idea why
         on E:Exception do
         begin
            log(E.ClassName + ' raised ' + E.Message + ' - disabling speech', false);
            speakTitles := false;
            speakArticles := false;
         end;
      end;
   end;
end;


{
returns a value between -100 and +100 indicating how relevant a piece of text is
-100 = totally irrelevant
0 = neutral
+100 = very relevant
}
function TMainThread.checkRelevance(theText: string): integer;
var
   words: TStringList;
begin
   log('Checking relevance', true);
   result := 0;
   words := getCleanWordList(theText);
   try
      if words.Count = 0 then exit; // avoids division by zero at the end

      // first we see how popular this word is
      // i.e. how many times it has appeared in an article that
      // was rated + or - by the user
      result := checkSimpleRelevance(words);

      // only perform deep word scan if result from the basic search is positive
      // it's very unlikely we would get back a positive relationship result from words
      // that were all negative, so we can save the overhead of a deep scan
      if result > 0 then
      begin
         // now figure in the results from the relationship table
         // this checks to see whether words in this text appeared together
         // previously in articles rated + or - by the user
         // we add this to the previous result, then divide by 2 to get the final result
         result := (result + checkRelevanceInRelTable(words)) div 2;
         log('Relationship relevance=' + IntToStr(result) + '%', true);
         // result should be between -100 and +100
         assert((result <= 100) and (result >= -100));
      end;
   finally
      words.free;
   end;
end;


{performs a simple relevance check on the word weightings table}
function TMainThread.checkSimpleRelevance(var words: TStringList): integer;
var
   i,j,r: integer;
begin
   result := 0;
   for i := 0 to words.count-1 do
   begin
      j := relevantWords.IndexOf(words[i]);
      if j >= 0 then
      begin
         // get word weighting as a % of the max word weight
         r := (relevantWords.getValueAt(j)*100) div maxWordWeight;
         result := result + r;
      end;
   end;
   result := result div words.count;
   log('Relevance=' + IntToStr(result) + '%', true);

   // result should be between -100 and +100
   assert((result <= 100) and (result >= -100));
end;


{
returns a value between -100 and +100 indicating how relevant a piece of text is
using the relationship table, i.e. how well the words relate to each other
-100 = totally unrelated, i.e. words have not appeared together in text rated highly by the user,
or appeared together in text rated negatively by the user
0 = neutral
+100 = very related, i.e. words have appeared together in text rated highly by the user
}
function TMainThread.checkRelevanceInRelTable(var words: TStringList): integer;
var
   wordsFound,i,j,k,index1,index2,r: integer;
   start: COMP;
   cacheArray: array of integer;
begin
   result := 0;
   wordsFound := 0;
   removeDuplicates(words);
   if words.Count < 2 then exit;
   log('Checking ' + IntToStr(words.count) + ' words against word relationship table', true);
   start := currentTimeMillis;
   result := 0;

   // to save continually looking up the word indices, look them up
   // once & save in an array
   setLength(cacheArray,words.count);
   for i := 0 to words.count-1 do
      cacheArray[i] := relevantWords.indexOf(words[i]);

   for i := 0 to words.count-1 do
   begin
      index1 := cacheArray[i];
      if index1 = -1 then continue;
      inc(wordsFound);
      for j:= i to words.count-1 do
      begin
         if i = j then continue;
         index2 := cacheArray[j];
         if index2 = -1 then continue;

         // get relationship weight between these words as a % of the max word weight
         k := findLinkIndex(index1, index2);
         if (k <> -1) then
            r := (wordLinks[k].strength*100) div maxWordWeight
         else
            r := 0;

         // log('Rel between ' + words[i] + ' & ' + words[j] + ' = ' + IntToStr(r),false);

         // we multiply by 2 here because we are only scanning half the words for efficiency
         // i.e. if we know that the rel between IRAN and NUCLEAR is 5, there is no need to
         // check the rel between NUCLEAR and IRAN because it will be the same
         // however, we still add it on so that the result would be identical
         // to result from doing a full scan of all elements in the table
         result := result + (r*2);
      end;
   end;

   log('Word relationship scan of ' + IntToStr(words.count) + ' words took ' + FloatToStr(currentTimeMillis-start), true);

   if wordsFound < 2 then exit; // prevent division by zero

   // divide total by number of possible combinations
   // result := result div (words.count*(words.count-1));

   // CHANGE - we now only count the words we know about
   // technically this gives a less "pure" result, but otherwise
   // the result is always 0% or 1% which is useless
   result := result div (wordsFound*(wordsFound-1));

   // final result should be between -100 and +100
   assert((result <= 100) and (result >= -100));
end;


{cleans up a piece of text by removing HTML, punctuation, common words, small words etc.}
function TMainThread.getCleanWordList(theText: string): TStringList;
var
   i: integer;
begin
   theText := trim(uppercase(removeHTML(theText,false)));

   // replace some common grammar
   theText := StringReplace(theText, chr(39) + 'S', '', [rfReplaceAll, rfIgnoreCase]);

   // remove all other apostrophes
   theText := StringReplace(theText, '''', '', [rfReplaceAll, rfIgnoreCase]);

   // rip out any non-alphabetic characters/spaces
   theText := removeNonAlphabetic(theText);

   // split up into words
   result := parseString(theText, ' ');

   // clean up the list of words
   for i := result.count-1 downto 0 do
   begin
      result[i] := trim(result[i]);

      // remove words that are too short or too long
      if (length(result[i]) < minWordLength) or (length(result[i]) > maxWordLength) then
      begin
         result.Delete(i);
         continue;
      end;

      // because we don't want separate weightings for APPLE and APPLES,
      // we remove any trailing 'S' from the word (if it's long enough)
      // unfortunately this may cause things like "JONES" to become "JONE"
      // but this shouldn't affect the ratings, unless there are words that
      // have a totally different meaning when the 'S' is removed
      // (I can't think of any, but if you can then please let me know)
      // (exclude words ending in double S, e.g. CROSS, MESS
      if (length(result[i]) > minWordLength) and (copy(result[i], length(result[i]), 1) = 'S')  and (copy(result[i], length(result[i])-1, 1) <> 'S') then
         result[i] := copy(result[i], 1, length(result[i])-1);

      // remove any common words such as AND, THE, etc
      if (findStringInSortedList(result[i],commonwords)) then
         result.Delete(i);
   end;
end;


{returns the index in the links array of a link between 2 words
or -1 if no link exists
FIXME ought to make this more efficient, at present it just trawls the entire list}
function TMainThread.findLinkIndex(index1, index2: integer): integer;
var
   i: integer;
begin
   result := -1;
   for i := 0 to length(wordLinks) - 1 do
   begin
      if (wordLinks[i].word1 = index1) and (wordLinks[i].word2 = index2) then
      begin
         result := i;
         break;
      end;
   end;
end;


{
scans a particular feed for keywords
if keywords found, the function returns the line that matched
if no keywords found, the function returns ''
}
function TMainThread.scanKeywords(var feed: TFeed; textToSearch: string): keywordScanResult;
var
   keywordsOnALine: TStringList;
   i,j,k,found: integer;
   tmpKeywords: string;
   keywordSet: TKeywordSet;
begin
   {keywords is a list of strings in the format:
   'gary,mckinnon,pentagon'
   'jordan,arabs,middle east,!katie price

   all keywords must be found on a line for a match to be found
   }

   result.matchingKeywords := '';
   result.matchCount := 0;

   // iterate over keyword sets associated with this feed
   for k := 0 to feed.keywordSets.count-1 do
   begin
      keywordSet := findKeywordSetByName(feed.keywordSets.Strings[k]);
      log('Scanning keyword set ' + keywordSet.name,true);

      // iterate over each keyword line in this keyword set
      for i := 0 to keywordSet.keywords.count-1 do
      begin
         // ignore case
         tmpKeywords := uppercase(keywordSet.keywords[i]);

         // ignore blank lines
         if length(tmpKeywords) = 0 then
         begin
            log('No keywords',true);
            continue;
         end;

         log('Searching for ' + tmpKeywords,true);

         // break up each line into keywords
         keywordsOnALine := parseString(tmpKeywords, ',');
         try
            // see if each keyword was found on this line
            found := 0;
            for j := 0 to keywordsOnALine.Count-1 do
            begin
               // see if word must *not* be found, e.g. !iran
               if copy(keywordsOnALine[j], 1, 1) = '!' then
               begin
                  if pos(copy(keywordsOnALine[j],2, length(keywordsOnALine[j])-1),uppercase(textToSearch)) > 0 then
                  begin
                     found := -1;
                     break;
                  end
                  else
                     inc(found);
               end
               else
               begin
                  // see if word *must* be found
                  if pos(keywordsOnALine[j],uppercase(textToSearch)) > 0 then inc(found);
               end;
            end;

            // if all required keywords are found, we have a match
            if found = keywordsOnALine.count then
            begin
               // ignore matches we have already seen, this can occur if the same keyword appears from multiple keyword sets
               if pos(tmpKeywords,result.matchingKeywords) = 0 then
               begin
                  if length(result.matchingKeywords) > 0 then result.matchingKeywords := result.matchingKeywords + ' & ';
                  result.matchingKeywords := result.matchingKeywords + tmpKeywords;
                  inc(result.matchCount); // track how many keyword lines match, the more matches, the higher the relevance
               end;
            end
            else
               log('No match found for ' + tmpKeywords,true);
         finally
            keywordsOnALine.free;
         end;
      end;
   end;
end;


function TMainThread.findKeywordSetByName(name: string): TKeywordSet;
var
   i: integer;
begin
   for i := 0 to length(keywordSetList)-1 do
   begin
      if keywordSetList[i].name = name then
      begin
         result := keywordSetList[i];
         exit;
      end;
   end;

   // result := nil;
end;


{update relevance tables using all recently rated articles}
procedure TMainThread.updateUserRatings;
var
   i: integer;
   cleanText: string;
begin
   saveLock.Enter;
   try
      for i := 0 to length(articles)-1 do
      begin
         if articles[i].reapplyRelevance then
         begin
            // remove any previous rating, otherwise we'll end up applying it twice for a single article
            if articles[i].previousRelevanceRatingFromUser <> 0 then
            begin
               log('Updating relevance for article: ' + articles[i].title + ' from ' + IntToStr(articles[i].previousRelevanceRatingFromUser) + ' to ' + IntToStr(articles[i].relevanceRatingFromuser), false);
               updateRelevance(0-articles[i].previousRelevanceRatingFromUser, articles[i].title + ' ' + articles[i].description);
            end
            else
               log('Setting relevance for article: ' + articles[i].title + ' to ' + IntToStr(articles[i].relevanceRatingFromuser), false);

            updateRelevance(articles[i].relevanceRatingFromuser, articles[i].title + ' ' + articles[i].description);
            articles[i].reapplyRelevance := false;

            // now re-evaluate this article to get an updated rating
            // this won't display until the next time the GUI is updated
            cleanText := removeHtml(articles[i].title + ' ' + articles[i].description,false);
            articles[i].relevanceRatingFromHistory := checkRelevance(cleanText);
            articles[i].header := 'Article found, relevance=' + IntToStr(articles[i].relevanceRatingFromHistory) + '%';
         end;
      end;
   finally
      saveLock.Leave;
   end;
end;


{updates the word-weightings using a piece of text}
procedure TMainThread.updateRelevance(relevance: integer; theText: string);
var
   words: TStringList;
   i,j,r: integer;
begin
   if relevance = 0 then exit;

   log('Updating relevance', true);
   words := mainThread.getCleanWordList(theText);
   try
      // go through list of words, adding/updating relevance waitings
      // each time a word is found, we increase/decrease its weighting
      // by the relevance factor specified by the user
      for i := 0 to words.count-1 do
      begin
         j := relevantWords.IndexOf(words[i]);
         if j = -1 then
         begin
            // new word - add it to the list and set initial relevance
            relevantWords.put(words[i],relevance);
         end
         else
         begin
            // we already have this word so update its relevance
            // by adding the value indicated by the user
            // weightings have a min & max value to stop runaway values
            r := relevantWords.getValueAt(j);
            r := r + relevance;
            if r > maxWordWeight then r := maxWordWeight;
            if r < 0-maxWordWeight then r := 0-maxWordWeight;
            relevantWords.setValueAt(j,r);
         end;
      end;

      // update the word-relationship table
      updateRelTable(words, relevance);
   finally
      words.free;
   end;
   relevantWordsChanged := true;
end;


{
updates the table holding the relationship between words
this works as follows: imagine the user rates the following 2 articles
THE KING OF JORDAN IS CALLED ABDULLAH (rated +5 by the user)
JORDAN ALSO KNOWN AS KATIE PRICE IS A CELEBRITY (rated -3 by the user)
the relevance table will record the fact that the user prefers articles
about King Abdullah of Jordan over articles about Jordan the celebrity
}
procedure TMainThread.updateRelTable(var words: TStringList; relevance: integer);
var
   i,j,k,index1,index2: integer;
   cacheArray: array of integer;
begin
   log('Updating rel table', true);
   removeDuplicates(words);

   // to save continually looking up the word indices, look them up
   // once & save in an array
   setLength(cacheArray,words.count);
   for i := 0 to words.count-1 do
      cacheArray[i] := relevantWords.indexOf(words[i]);

   for i := 0 to words.count-1 do
   begin
      index1 := cacheArray[i];
      // log(inttostr(i) + '/' + inttostr(words.count-1), true);
      for j := 0 to words.count-1 do
      begin
         if i = j then continue;
         index2 := cacheArray[j];
         k := mainThread.findLinkIndex(index1, index2);
         if k > -1 then
         begin
            // link already exists, so update the strength
            with wordLinks[k] do
            begin
               strength := strength + relevance;
               if strength > maxWordWeight then strength := maxWordWeight;
               if strength < 0-maxWordWeight then strength := 0-maxWordWeight;
            end;
         end
         else
         begin
            // add new link
            setLength(wordLinks, length(wordLinks)+1);
            with wordLinks[length(wordLinks)-1] do
            begin
               word1 := index1;
               word2 := index2;
               strength := relevance;
            end;
         end;
      end;
   end;

   relevantWordsChanged := true;
end;



procedure TMainThread.log(line: string; isVerbose: boolean);
begin
   if (not verboseOutput) and (isVerbose) then exit;
   frmMain.logEntry := line;
   synchronize(frmMain.logFromOtherThread);
end;


function TMainThread.isSupportedImage(filename: string): boolean;
var
   ext: string;
begin
   ext := uppercase(ExtractFileExt(filename));

   result := (ext = '.JPG') or
             (ext = '.PNG') or
             (ext = '.GIF');
end;


procedure TMainThread.downloadOutstandingImages;
var
   i: integer;
begin
   for i := 0 to length(articles)-1 do
   begin
      if terminated then break;
      
      if (frmMain.showImages) and (articles[i].imageNumber = 0) and (isSupportedImage(articles[i].imageUrl)) then
      begin
         if downloadImages then
         begin
            if downloadFile(articles[i].imageUrl, 'image_' + IntToStr(imageSeq) + ExtractFileExt(articles[i].imageUrl), false, 0) = '' then
            begin
               articles[i].imageNumber := imageSeq;
               inc(imageSeq);
            end
            else
            begin
               // give up after 5 failures
               inc(articles[i].imageDownloadAttempts);
               if articles[i].imageDownloadAttempts >= 5 then articles[i].imageUrl := '';
            end;
         end
         else
         begin
            // for testing - don't download images every time
            articles[i].imageNumber := imageSeq;
            inc(imageSeq);
         end;
      end;
   end;
end;


procedure TMainThread.saveArticlesToKeep;
var
   i: integer;
   f: textfile;
   tmp: string;
begin
   saveLock.Enter;
   try
      try
         for i := 0 to length(articles)-1 do
         begin
            with articles[i] do
            begin
               if (keep) and (not savedToDisk) then
               begin
                  log('Saving article: ' + title, false);
                  AssignFile(f, articlesDir + '\' + uniqueId);
                  rewrite(f);
                  writeln(f, link);
                  writeln(f, title);
                  writeln(f, header);
                  tmp := description;
                  tmp := StringReplace(tmp, chr(13), CR, [rfReplaceAll, rfIgnoreCase]);
                  tmp := StringReplace(tmp, chr(10), LF, [rfReplaceAll, rfIgnoreCase]);
                  writeln(f, tmp);
                  writeln(f, imageUrl);
                  writeln(f, IntToStr(relevanceRatingFromHistory));
                  writeln(f, IntToStr(relevanceRatingFromUser));
                  writeln(f, DateTimeToStr(timestamp));
                  closefile(f);
                  savedToDisk := true;
               end;
            end;
         end;
      except
         on e:exception do
         begin
            log('Error saving articles: ' + e.ClassName + ': ' + e.Message,false);
         end;
      end;
   finally
      saveLock.Leave;
   end;
end;


end.

