program pheedstorm;

uses
  Forms,
  Windows,
  Messages,
  Dialogs,
  showbigtext in 'showbigtext.pas' {frmShowBigText},
  feeds in 'feeds.pas' {frmFeeds},
  LibXmlParser in '..\common\xmlparser\LibXmlParser.pas',
  utils in '..\common\utils.pas',
  linklabel in '..\common\linklabel.pas',
  stringmap in '..\common\stringmap.pas',
  main in 'main.pas' {frmMain},
  compmap in '..\common\compmap.pas',
  shortintmap in '..\common\shortintmap.pas',
  splashscreen in 'splashscreen.pas' {frmSplashScreen},
  samplefeeds in 'samplefeeds.pas' {frmSampleFeeds},
  generic in 'generic.pas',
  keywordsets in 'keywordsets.pas' {frmKeywordSets},
  zlibpas in '..\common\pngdelphi\zlibpas.pas',
  pngextra in '..\common\pngdelphi\pngextra.pas',
  pngimage in '..\common\pngdelphi\pngimage.pas',
  pnglang in '..\common\pngdelphi\pnglang.pas',
  about in 'about.pas' {frmAbout},
  SpeechLib_TLB in '..\common\sapi\SpeechLib_TLB.pas',
  newsticker in 'newsticker.pas' {frmNewsTicker};

{$R *.RES}

const
   uniqueString = 'This didnt come from Protovision';

var
   hMapping: THandle;
   copyDataStruct : TCopyDataStruct;
   receiverHandle  : THandle;
   params: string;
begin
  frmSplashScreen := TfrmSplashScreen.create(application);
  frmSplashScreen.show;
  frmSplashScreen.update;
  Application.Initialize;

   // prevent multiple instances running on a single PC
   hMapping := CreateFileMapping(HWND($FFFFFFFF), nil,PAGE_READONLY, 0, 32, PChar(uniqueString));
   if (hMapping <> 0) and (GetLastError <> 0) and (not runningWithinDelphiIDE) then
   begin
      // if any command-line parameters were passed in, send them to the running instance
      // this should be a URL to subscribe to automatically
      params := getArgs;
      if length(params) > 0 then
      begin
         copyDataStruct.dwData := 0; //use it to identify the message contents
         copyDataStruct.cbData := 1 + Length(params) ;
         copyDataStruct.lpData := PChar(params) ;
         receiverHandle := FindWindow(PChar('TfrmMain'),PChar('Pheedstorm'));
         assert(receiverHandle > 0);
         SendMessage(receiverHandle, WM_COPYDATA, Integer(Application.Handle), Integer(@copyDataStruct));
      end
      else
         ShowMessage('Another instance is already running');
   end
   else
   begin
      Application.CreateForm(TfrmMain, frmMain);
  Application.CreateForm(TfrmFeeds, frmFeeds);
  frmMain.Initialise;
      Application.Run;
   end;
end.
