unit splashscreen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmSplashScreen = class(TForm)
    Label1: TLabel;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
  private
    { Private declarations }
  public
    { Public declarations }
    procedure updateDetails(labelText: string; progressPos, maxAmount, percentageShow: integer); overload;
    procedure updateDetails(labelText: string; progressPos: integer); overload;
  end;

var
  frmSplashScreen: TfrmSplashScreen;

implementation

{$R *.dfm}


{the reason for this method is as follows:
if we are iterating over a loop with thousands of entries,
updating the progress bar on every iteration is very expensive,
so this method provides the option to update the progress bar
at percentage intervals, e.g. every time 10% more of the loop is reached,
update the progress bar
}
procedure TfrmSplashScreen.updateDetails(labelText: string; progressPos, maxAmount, percentageShow: integer);
begin
   if (maxAmount >= percentageShow) and (((progressPos+1) mod (maxAmount div percentageShow)) = 0) then
      updateDetails(labelText,((progressPos * 100) div maxAmount));

end;

procedure TfrmSplashScreen.updateDetails(labelText: string; progressPos: integer);
begin
   if not visible then show;
   BringToFront;
   label1.Caption := labelText;
   ProgressBar1.Position := progressPos;
   application.processMessages;
end;

end.
